﻿function DPanel_OnLoad (panel)
	panel.name = "GOATS"
	InterfaceOptions_AddCategory(panel);
end 

local frame = CreateFrame("FRAME"); -- Need a frame to respond to events
frame:RegisterEvent("ADDON_LOADED"); -- Fired when saved variables are loaded
frame:RegisterEvent("PLAYER_LOGOUT"); -- Fired when about to log out
frame:RegisterEvent("WORLD_MAP_UPDATE");
frame:RegisterEvent("UNIT_PET");


function frame:OnEvent(event, ...)
	if event == "ADDON_LOADED" then
		GOATS_MinimapButton_Reposition();
		GOATS_setModel(unit);
		DemonListFrameTotals:SetText(format(ERR_ZONE_EXPLORED, GOATS_tcount(DNAMES)));

		DemonOptionsPanelNormal:SetTextColor(GOATS_Colors.Normal.R, GOATS_Colors.Normal.G, GOATS_Colors.Normal.B)
		DemonOptionsPanelElite:SetTextColor(GOATS_Colors.Elite.R, GOATS_Colors.Elite.G, GOATS_Colors.Elite.B)
		DemonOptionsPanelCommented:SetTextColor(GOATS_Colors.Commented.R, GOATS_Colors.Commented.G, GOATS_Colors.Commented.B)
		DemonOptionsPanelCommentedElite:SetTextColor(GOATS_Colors.CommentedElite.R, GOATS_Colors.CommentedElite.G, GOATS_Colors.CommentedElite.B)

		DemonOptionsPanelNormalPickerVar:SetVertexColor(GOATS_Colors.Normal.R, GOATS_Colors.Normal.G, GOATS_Colors.Normal.B)
		DemonOptionsPanelElitePickerVar:SetVertexColor(GOATS_Colors.Elite.R, GOATS_Colors.Elite.G, GOATS_Colors.Elite.B)
		DemonOptionsPanelCommentedPickerVar:SetVertexColor(GOATS_Colors.Commented.R, GOATS_Colors.Commented.G, GOATS_Colors.Commented.B)
		DemonOptionsPanelCommentedElitePickerVar:SetVertexColor(GOATS_Colors.CommentedElite.R, GOATS_Colors.CommentedElite.G, GOATS_Colors.CommentedElite.B)
	end
	if (event == "WORLD_MAP_UPDATE") then
		MapIconNormal:Hide();
		MapIconElite:Hide();
	end
end

frame:SetScript("OnEvent", frame.OnEvent);



GOATS_MiniButton = {
	MinimapPos = -62
}
GOATS_Colors = {
	Normal = {		--yellow
		R = 1.0,
		G = 0.82,
		B = 0,
	},
	Elite = {		--legendary
		R = 1.0,
		G = 0.49,
		B = 0.04,
	},
	Commented = {		--white
		R = 1,
		G = 1,
		B = 1,
	},
	CommentedElite = {	--red
		R = 0.78,
		G = 0.61,
		B = 0.43,
	}
}
	
DNAMES = {}
DLEVELS = {}
RaceListDatabase = {}
DARMORS = {}
DHEALTHS = {}
DMANAS = {}
DSTAT1S = {}
DSTAT2S = {}
DSTAT3S = {}
DSTAT4S = {}
DSTAT5S = {}
RES1 = {}
RES2 = {}
RES3 = {}
RES4 = {}
RES5 = {}

IMMUNES = {}
DemonIDDB = {}
DCOMMENTS = {}

SKILLNAME1S = {}
SKILLSUBTEXT1S = {}
SKILLTEXTURE1S = {}
SKILLID1S = {}
SKILLNAME2S = {}
SKILLSUBTEXT2S = {}
SKILLTEXTURE2S = {}
SKILLID2S = {}
SKILLNAME3S = {}
SKILLSUBTEXT3S = {}
SKILLTEXTURE3S = {}
SKILLID3S = {}
SKILLNAME4S = {}
SKILLSUBTEXT4S = {}
SKILLTEXTURE4S = {}
SKILLID4S = {}

DATPOWERS = {}
DELITES = {}
DZONES = {}
DZONEINDEXS = {}
DCONTINENTINDEXS = {}
DCOORDXS = {}
DCOORDYS = {}

DPERCENTS = {}
DMINDMGS = {}
DMAXDMGS = {}
DMINODMGS = {}
DMAXODMGS = {}
DSPEEDS = {}
DOSPEEDS = {}

CritChanceFromAgilitys = {}
UnitHealthModifiers = {}
UnitMaxHealthModifiers = {}
UnitPowerModifiers = {}
SpellCritChanceFromIntellects = {}
--UnitHealthRegenRateFromSpirits = {}
UnitManaRegenRateFromSpirits = {}


function GOATS_MinimapButton_Reposition()
	GOATS_MinimapButton:SetPoint("TOPLEFT","Minimap","TOPLEFT",52-(80*cos(GOATS_MiniButton.MinimapPos)),(80*sin(GOATS_MiniButton.MinimapPos))-52)
end

function GOATS_MinimapButton_DraggingFrame_OnUpdate()
	local xpos,ypos = GetCursorPosition()
	local xmin,ymin = Minimap:GetLeft(), Minimap:GetBottom()

	xpos = xmin-xpos/UIParent:GetScale()+70
	ypos = ypos/UIParent:GetScale()-ymin-70

	GOATS_MiniButton.MinimapPos = math.deg(math.atan2(ypos,xpos))
	GOATS_MinimapButton_Reposition()
end

function ColorPicker_OnClick(r, g, b, changedCallback)
	ColorPickerFrame:Hide();	-- Need to run the OnShow handler.
	ColorPickerFrame.func, ColorPickerFrame.cancelFunc = changedCallback, changedCallback;
	ColorPickerFrame:SetColorRGB(r,g,b);
	ColorPickerFrame.previousValues = {r,g,b};

	ColorPickerFrame:Show();
end

function DemonNormalCallback(restore)
	local newRn, newGn, newBn;
	if restore then
		newRn, newGn, newBn = unpack(restore)
	else
		newRn, newGn, newBn = ColorPickerFrame:GetColorRGB();
	end

	GOATS_Colors.Normal.R, GOATS_Colors.Normal.G, GOATS_Colors.Normal.B = newRn, newGn, newBn;
	DemonListScrollFrame_Update()
	DemonOptionsPanelNormal:SetTextColor(GOATS_Colors.Normal.R, GOATS_Colors.Normal.G, GOATS_Colors.Normal.B)
	DemonOptionsPanelNormalPickerVar:SetVertexColor(GOATS_Colors.Normal.R, GOATS_Colors.Normal.G, GOATS_Colors.Normal.B)
end
function DemonEliteCallback(restore)
	local newRe, newGe, newBe;
	if restore then
		newRe, newGe, newBe = unpack(restore)
	else
		newRe, newGe, newBe = ColorPickerFrame:GetColorRGB();
	end

	GOATS_Colors.Elite.R, GOATS_Colors.Elite.G, GOATS_Colors.Elite.B = newRe, newGe, newBe;
	DemonListScrollFrame_Update()
	DemonOptionsPanelElite:SetTextColor(GOATS_Colors.Elite.R, GOATS_Colors.Elite.G, GOATS_Colors.Elite.B)
	DemonOptionsPanelElitePickerVar:SetVertexColor(GOATS_Colors.Elite.R, GOATS_Colors.Elite.G, GOATS_Colors.Elite.B)
end
function DemonCommentedCallback(restore)
	local newRc, newGc, newBc;
	if restore then
		newRc, newGc, newBc = unpack(restore)
	else
		newRc, newGc, newBc = ColorPickerFrame:GetColorRGB();
	end

	GOATS_Colors.Commented.R, GOATS_Colors.Commented.G, GOATS_Colors.Commented.B = newRc, newGc, newBc;
	DemonListScrollFrame_Update()
	DemonOptionsPanelCommented:SetTextColor(GOATS_Colors.Commented.R, GOATS_Colors.Commented.G, GOATS_Colors.Commented.B)
	DemonOptionsPanelCommentedPickerVar:SetVertexColor(GOATS_Colors.Commented.R, GOATS_Colors.Commented.G, GOATS_Colors.Commented.B)
end
function DemonCommentedEliteCallback(restore)
	local newRce, newGce, newBce;
	if restore then
		newRce, newGce, newBce = unpack(restore)
	else
		newRce, newGce, newBce = ColorPickerFrame:GetColorRGB();
	end

	GOATS_Colors.CommentedElite.R, GOATS_Colors.CommentedElite.G, GOATS_Colors.CommentedElite.B = newRce, newGce, newBce;
	DemonListScrollFrame_Update()
	DemonOptionsPanelCommentedElite:SetTextColor(GOATS_Colors.CommentedElite.R, GOATS_Colors.CommentedElite.G, GOATS_Colors.CommentedElite.B)
	DemonOptionsPanelCommentedElitePickerVar:SetVertexColor(GOATS_Colors.CommentedElite.R, GOATS_Colors.CommentedElite.G, GOATS_Colors.CommentedElite.B)
end


function GOATS_MinimapButton_OnClick()
	if (GetMouseButtonClicked()=="RightButton") then
--	 ReloadUI();
		DemonListFrame_Track()
	elseif (GetMouseButtonClicked()=="LeftButton") then
 		GOATS_Toggle(msg);
	elseif (GetMouseButtonClicked()=="MiddleButton") then
 		InterfaceOptionsFrame_OpenToCategory("GOATS");
	end
end

function GOATS_tremovebyval(tab, val)
	for k,v in pairs(tab) do
		if(v==val) then
			table.remove(tab, k);
			return true;
		end
	end
	return false;
end

function GOATS_tcount(tab)
	local n = #tab
	if (n == 0) then
		for _ in pairs(tab) do
			n = n + 1
		end
	end
	return n
end

StaticPopupDialogs["GOATS_Confirm_Dialog"] = {
  text = _G["D_CONFIRM"],
  button1 = _G["YES"],
  button2 = _G["NO"],
  OnAccept = function()
      DemonListDeleteButton_OnClick()
  end,
  timeout = 0,
  whileDead = true,
  hideOnEscape = true,
  showAlert = true,
  cancels = "GOATS_Comment_Dialog",
}


local waitTable = {};
local waitFrame = nil;

function GOATS_wait(delay, func, ...)
  if(type(delay)~="number" or type(func)~="function") then
    return false;
  end
  if(waitFrame == nil) then
    waitFrame = CreateFrame("Frame","WaitFrame", UIParent);
    waitFrame:SetScript("onUpdate",function (self,elapse)
      local count = #waitTable;
      local i = 1;
      while(i<=count) do
        local waitRecord = tremove(waitTable,i);
        local d = tremove(waitRecord,1);
        local f = tremove(waitRecord,1);
        local p = tremove(waitRecord,1);
        if(d>elapse) then
          tinsert(waitTable,i,{d-elapse,f,p});
          i = i + 1;
        else
          count = count - 1;
          f(unpack(p));
        end
      end
    end);
  end
  tinsert(waitTable,{delay,func,{...}});
  return true;
end

function DemonListFrame_OnEvent(self, event, ...)
	if event == "COMBAT_LOG_EVENT_UNFILTERED" then
		local arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12 = ...;
		if arg2 == "SPELL_AURA_APPLIED" then
			if arg6 == UnitGUID("target") and arg10 == GetSpellInfo(61191) then
				--Unending Breath--5697
				GOATS_wait(0.5, DemonListFrame_Track);
			end
		elseif arg2 == "SPELL_MISSED" then
			DOCRAP = UnitName("target")
			if arg6 == UnitGUID("target") and arg10 == GetSpellInfo(61191) and arg12 == "IMMUNE" then
				UIErrorsFrame:AddMessage("|c00FF6600GOATS:|r "..Immune_Call, 1.0, 1.0, 0, 1, 10)
				if ( not tContains(IMMUNES, UnitName("target")) ) then
					table.insert(IMMUNES, DOCRAP)
				end
			end
		end
	elseif event == "UPDATE_MOUSEOVER_UNIT" then
		if ( UnitCreatureType("mouseover") == D_DEMON ) then
			if (tContains(DNAMES, UnitName("mouseover"))) then
				GameTooltip:AddLine("|c00FF6600GOATS:|r "..Can_be_Enslaved, 1, 0.82, 0);
				GameTooltip:Show();
			elseif (tContains(IMMUNES, UnitName("mouseover"))) then
				GameTooltip:AddLine("|c00FF6600GOATS:|r "..Immune_to_Enslave, 1, 0.82, 0);
				GameTooltip:Show();
			else
				GameTooltip:AddLine("|c00FF6600GOATS:|r "..Unknown_to_Enslave, 1, 0.82, 0);
				GameTooltip:Show();
			end
		end
	end
	DemonListFrameTotals:SetText(format(ERR_ZONE_EXPLORED, GOATS_tcount(DNAMES)));
end

function DemonListFrame_Track()

	DNAME = UnitName("pet")
	DLEVEL = UnitLevel("pet")
	DARMOR = UnitArmor("pet")
	DHEALTH = UnitHealthMax("pet")
	DMANA = UnitManaMax("pet")
	DSTAT1 = UnitStat("pet", 1)
	DSTAT2 = UnitStat("pet", 2)
	DSTAT3 = UnitStat("pet", 3)
	DSTAT4 = UnitStat("pet", 4)
	DSTAT5 = UnitStat("pet", 5)
	DATPOWER = UnitAttackPower("pet")
	DELITE = UnitClassification("pet");
	DZONE = GetRealZoneText();
	DZONEINDEX = GetCurrentMapAreaID();
	if (IsInInstance() == nil) then
		DCONTINENTINDEX = "NoInstance";
	else
		DCONTINENTINDEX = GetCurrentMapDungeonLevel();
	end
	DCOORDX, DCOORDY = GetPlayerMapPosition("player");
	Dspeed, DoffhandSpeed = UnitAttackSpeed("pet");
	if (not DoffhandSpeed) then
		DoffhandSpeed = ""
	end
	DminDamage, DmaxDamage, DminOffHandDamage, DmaxOffHandDamage, DphysicalBonusPos, DphysicalBonusNeg, Dpercent = UnitDamage("pet");
	CritChanceFromAgility = GetCritChanceFromAgility("pet")
	UnitHealthModifier = GetUnitHealthModifier("pet")
	UnitMaxHealthModifier = GetUnitMaxHealthModifier("pet")
	UnitPowerModifier = GetUnitPowerModifier("pet")
	SpellCritChanceFromIntellect = GetSpellCritChanceFromIntellect("pet")
--	UnitHealthRegenRateFromSpirit = GetUnitHealthRegenRateFromSpirit("pet")
	UnitManaRegenRateFromSpirit = GetUnitManaRegenRateFromSpirit("pet")

	DemonActionBar_Track();
	DemonFrame_GetResistances();

		if UnitExists("pet") then
			if (tContains(DNAMES, DNAME) == nil) then
			--	DemonDataFrame:Hide();
				UIErrorsFrame:AddMessage("|c00FF6600GOATS:|r "..New_Tracked, 1.0, 1.0, 0, 1, 10);
				SetMapToCurrentZone();
				DemonActionBar_Track();
				DemonRaceSet()
				DCOMMENT = "??";


				table.insert(DNAMES, DNAME);
				table.insert(DLEVELS, DLEVEL);
				table.insert(DARMORS, DARMOR);
				table.insert(DHEALTHS, DHEALTH);
				table.insert(DMANAS, DMANA);
				table.insert(DSTAT1S, DSTAT1);
				table.insert(DSTAT2S, DSTAT2);
				table.insert(DSTAT3S, DSTAT3);
				table.insert(DSTAT4S, DSTAT4);
				table.insert(DSTAT5S, DSTAT5);
				table.insert(DATPOWERS, DATPOWER);

				table.insert(DPERCENTS, Dpercent);
				table.insert(DMINDMGS, DminDamage);
				table.insert(DMAXDMGS, DmaxDamage);
				table.insert(DMINODMGS, DminOffHandDamage);
				table.insert(DMAXODMGS, DmaxOffHandDamage);
				table.insert(DSPEEDS, Dspeed);
				table.insert(DOSPEEDS, DoffhandSpeed);

				table.insert(DELITES, DELITE);
				table.insert(DCOMMENTS, DCOMMENT);
				table.insert(DZONES, DZONE);
				table.insert(DZONEINDEXS, DZONEINDEX);
				table.insert(DCONTINENTINDEXS, DCONTINENTINDEX);
				table.insert(DCOORDXS, DCOORDX);
				table.insert(DCOORDYS, DCOORDY);
				table.insert(CritChanceFromAgilitys, CritChanceFromAgility);
				table.insert(UnitHealthModifiers, UnitHealthModifier);
				table.insert(UnitMaxHealthModifiers, UnitMaxHealthModifier);
				table.insert(UnitPowerModifiers, UnitPowerModifier);
				table.insert(SpellCritChanceFromIntellects, SpellCritChanceFromIntellect);
			--	table.insert(UnitHealthRegenRateFromSpirits, UnitHealthRegenRateFromSpirit);
				table.insert(UnitManaRegenRateFromSpirits, UnitManaRegenRateFromSpirit);
				table.insert(RES1, Rresistance1);
				table.insert(RES2, Rresistance2);
				table.insert(RES3, Rresistance3);
				table.insert(RES4, Rresistance4);
				table.insert(RES5, Rresistance5);

				table.insert(SKILLNAME1S, Dname4);
				table.insert(SKILLSUBTEXT1S, Dsubtext4);
				table.insert(SKILLTEXTURE1S, Dtexture4);
				table.insert(SKILLID1S, DemonId1);

				table.insert(SKILLNAME2S, Dname5);
				table.insert(SKILLSUBTEXT2S, Dsubtext5);
				table.insert(SKILLTEXTURE2S, Dtexture5);
				table.insert(SKILLID2S, DemonId2);
				
				table.insert(SKILLNAME3S, Dname6);
				table.insert(SKILLSUBTEXT3S, Dsubtext6);
				table.insert(SKILLTEXTURE3S, Dtexture6);
				table.insert(SKILLID3S, DemonId3);
				
				table.insert(SKILLNAME4S, Dname7);
				table.insert(SKILLSUBTEXT4S, Dsubtext7);
				table.insert(SKILLTEXTURE4S, Dtexture7);
				table.insert(SKILLID4S, DemonId4);

				DemonListFrameTotals:SetText(format(ERR_ZONE_EXPLORED, GOATS_tcount(DNAMES)));
				DemonListScrollFrame_Update()
			elseif (tContains(DNAMES, DNAME) == 1) then
				UIErrorsFrame:AddMessage("|c00FF6600GOATS:|r "..Already_Known, 1.0, 1.0, 0, 1, 10);
			end
		else
				UIErrorsFrame:AddMessage("|c00FF6600GOATS:|r "..No_Pet, 1.0, 1.0, 0, 1, 10);
		end
end


GOATS_DEMONID_MAX = 88000 --WoTLK Count (Change to 66000 for Cataclysm)
local GOATS_CC = 0;

DLIST_FRAME_DEMON_HEIGHT = 16;
DEMONS_TO_DISPLAY = 17;


DRACE1 = D_SUCCUBUS;
DRACE2 = D_FELGUARD;
DRACE3 = D_DREADLORD;
DRACE4 = D_IMP;
DRACE5 = D_SHIVAN;
DRACE6 = D_WRATHGUARD;
DRACE7 = D_VOIDWALKER;
DRACE8 = D_VOID_TERROR;
DRACE9 = D_FELHOUND;
DRACE10 = D_BOAR;
DRACE11 = D_VOIDWRAITH;
DRACE12 = D_OUTLANDSIMP;
DRACE13 = D_DARKHOUND;
DRACE14 = D_SATYR;
DRACE15 = D_BEHOLDER;
DRACE16 = D_GANARG;
DRACE17 = D_MOARG;
DRACE18 = D_CORE_HOUND;
DRACE19 = D_INFERNAL
DRACE20 = D_ABYSSAL
DRACE21 = D_DOOMGUARD
DRACE22 = D_FIEND
DRACE23 = D_PIT_LORD
DRACE24 = D_EREDAR
DRACE25 = D_NIGHTMARE
DRACE26 = D_UNKNOWN
DRACE27 = D_INFSOUL
DRACE28 = D_GARGOYLE
DRACE29 = D_ARMORWALKER

if GetLocale() == "esES" or ( GetLocale() == "esMX" ) then
	D_DEMON = "Demonio"
	Immune_Call = "¡El demonio es Inmune a Esclavizar!"
	New_Tracked = "¡Nuevo demonio esclavizado!"
	No_Pet = "No tienes mascota"
	Already_Known = "Ya conocido"
	Immune_to_Enslave = "Inmune a Esclavizar"
	Can_be_Enslaved = "Esclavizable"
	Unknown_to_Enslave = "Desconocido"
	D_CONFIRM = "\194\191Est\195\161s seguro?"
	D_SUCCUBUS = "S\195\186cubo";
	D_FELGUARD = "Guardia vil";
	D_DREADLORD = "Se\195\177or del terror";
	D_IMP = "Diablillo";
	D_SHIVAN = "Shiva\195\173sta";
	D_WRATHGUARD = "Guardia de c\195\179lera";
	D_VOIDWALKER = "Abisario";
	D_VOID_TERROR = "Terror del vac\195\173o";
	D_FELHOUND = "Man\195\161fago";
	D_BOAR = "Jabinferno";
	D_VOIDWRAITH = "Anima del vac\195\173o";
	D_OUTLANDSIMP = "Diablillo vil";
	D_DARKHOUND = "Can oscuro";
	D_SATYR = "S\195\161tiro";
	D_BEHOLDER = "Contemplador";
	D_GANARG = "Gan'arg";
	D_MOARG = "Mo'arg";
	D_CORE_HOUND = "Can del n\195\186cleo";
	D_INFERNAL = "Infernal";
	D_ABYSSAL = "Abisal";
	D_DOOMGUARD = "Guardia apocal\195\173ptico";
	D_FIEND = "Maligno";
	D_PIT_LORD = "Se\195\177or del foso";
	D_EREDAR = "Eredar";
	D_NIGHTMARE = "Pesadilla";
	D_UNKNOWN = "Desconocido";
	D_INFSOUL = "Alma";
	D_GARGOYLE = "G\195\161rgola";
	D_ARMORWALKER = "Abisario vil";

elseif GetLocale() == "frFR" then		--Thanks to Myriana at WowInterface
	D_DEMON = "D\195\169mon"
	Immune_Call = "Le démon est immunisé à l'asservissement!"
	New_Tracked = "Nouveau démon découvert!"
	No_Pet = "Vous n'avez pas de familier"
	Already_Known = "Déja connu"
	Immune_to_Enslave = "Immunisé à l'asservissement"
	Can_be_Enslaved = "Peut être asservi"
	Unknown_to_Enslave = "Inconnu"
	D_CONFIRM = "Etes vous sur?"
	D_SUCCUBUS = "Succube";
	D_FELGUARD = "Gangregarde";
	D_DREADLORD = "Seigneur de l'effroi";
	D_IMP = "Diablotin";
	D_SHIVAN = "Shivan";
	D_WRATHGUARD = "Garde-courroux";
	D_VOIDWALKER = "Marcheur du Vide";
	D_VOID_TERROR = "Terreur du Vide";
	D_FELHOUND = "Gangrechien";
	D_BOAR = "Sanglier infernal";
	D_VOIDWRAITH = "Ame en peine du Vide";
	D_OUTLANDSIMP = "Diablotin gangren\195\169";
	D_DARKHOUND = "Sombredogue";
	D_SATYR = "Satyre";
	D_BEHOLDER = "Spectateur";
	D_GANARG = "Gan'arg";
	D_MOARG = "Mo'arg";
	D_CORE_HOUND = "Chien du Magma";
	D_INFERNAL = "Infernal";
	D_ABYSSAL = "Abyssal";
	D_DOOMGUARD = "Garde funeste";
	D_FIEND = "Fiel";
	D_PIT_LORD = "Seigneur des ab\195\174mes";
	D_EREDAR = "Er\195\169dar";
	D_NIGHTMARE = "Cauchemardesque";
	D_UNKNOWN = "Inconnu";
	D_INFSOUL = "Ame";
	D_GARGOYLE = "Gargouille";
	D_ARMORWALKER = "Marcheur du Vide gangren\195\169";

elseif GetLocale() == "zhCN" then
	D_DEMON = "恶魔"
	Immune_Call = "Demon is Inmune to Enslave!"
	New_Tracked = "New demon tracked!"
	No_Pet = "You don't have a pet"
	Already_Known = "Already known"
	Immune_to_Enslave = "Immune to Enslave"
	Can_be_Enslaved = "Can be Enslaved"
	Unknown_to_Enslave = "Unknown"
	D_CONFIRM = "Are you sure?"
	D_SUCCUBUS = "Succubus";
	D_FELGUARD = "Felguard";
	D_DREADLORD = "Dreadlord";
	D_IMP = "Imp";
	D_SHIVAN = "Shivan";
	D_WRATHGUARD = "Wrathguard";
	D_VOIDWALKER = "Voidwalker";
	D_VOID_TERROR = "Void terror";
	D_FELHOUND = "Felhound";
	D_BOAR = "Helboar";
	D_VOIDWRAITH = "Voidwraith";
	D_OUTLANDSIMP = "Fel imp";
	D_DARKHOUND = "Dark hound";
	D_SATYR = "Satyr";
	D_BEHOLDER = "Beholder";
	D_GANARG = "Gan'arg";
	D_MOARG = "Mo'arg";
	D_CORE_HOUND = "Core hound";
	D_INFERNAL = "Infernal";
	D_ABYSSAL = "Abyssal";
	D_DOOMGUARD = "Doomguard";
	D_FIEND = "Fiend";
	D_PIT_LORD = "Pit lord";
	D_EREDAR = "Eredar";
	D_NIGHTMARE = "Nightmare";
	D_UNKNOWN = "Unknown";
	D_INFSOUL = "Soul";
	D_GARGOYLE = "Gargoyle";
	D_ARMORWALKER = "Fel voidwalker";

elseif GetLocale() == "deDE" then
	D_DEMON = "D\195\164mon"
	Immune_Call = "Demon is Inmune to Enslave!"
	New_Tracked = "New demon tracked!"
	No_Pet = "You don't have a pet"
	Already_Known = "Already known"
	Immune_to_Enslave = "Immune to Enslave"
	Can_be_Enslaved = "Can be Enslaved"
	Unknown_to_Enslave = "Unknown"
	D_CONFIRM = "Are you sure?"
	D_SUCCUBUS = "Succubus";
	D_FELGUARD = "Felguard";
	D_DREADLORD = "Dreadlord";
	D_IMP = "Imp";
	D_SHIVAN = "Shivan";
	D_WRATHGUARD = "Wrathguard";
	D_VOIDWALKER = "Voidwalker";
	D_VOID_TERROR = "Void terror";
	D_FELHOUND = "Felhound";
	D_BOAR = "Helboar";
	D_VOIDWRAITH = "Voidwraith";
	D_OUTLANDSIMP = "Fel imp";
	D_DARKHOUND = "Dark hound";
	D_SATYR = "Satyr";
	D_BEHOLDER = "Beholder";
	D_GANARG = "Gan'arg";
	D_MOARG = "Mo'arg";
	D_CORE_HOUND = "Core hound";
	D_INFERNAL = "Infernal";
	D_ABYSSAL = "Abyssal";
	D_DOOMGUARD = "Doomguard";
	D_FIEND = "Fiend";
	D_PIT_LORD = "Pit lord";
	D_EREDAR = "Eredar";
	D_NIGHTMARE = "Nightmare";
	D_UNKNOWN = "Unknown";
	D_INFSOUL = "Soul";
	D_GARGOYLE = "Gargoyle";
	D_ARMORWALKER = "Fel voidwalker";

elseif GetLocale() == "ruRU" then
	D_DEMON = "Демон"
	Immune_Call = "Demon is Inmune to Enslave!"
	New_Tracked = "New demon tracked!"
	No_Pet = "You don't have a pet"
	Already_Known = "Already known"
	Immune_to_Enslave = "Immune to Enslave"
	Can_be_Enslaved = "Can be Enslaved"
	Unknown_to_Enslave = "Unknown"
	D_CONFIRM = "Are you sure?"
	D_SUCCUBUS = "Succubus";
	D_FELGUARD = "Felguard";
	D_DREADLORD = "Dreadlord";
	D_IMP = "Imp";
	D_SHIVAN = "Shivan";
	D_WRATHGUARD = "Wrathguard";
	D_VOIDWALKER = "Voidwalker";
	D_VOID_TERROR = "Void terror";
	D_FELHOUND = "Felhound";
	D_BOAR = "Helboar";
	D_VOIDWRAITH = "Voidwraith";
	D_OUTLANDSIMP = "Fel imp";
	D_DARKHOUND = "Dark hound";
	D_SATYR = "Satyr";
	D_BEHOLDER = "Beholder";
	D_GANARG = "Gan'arg";
	D_MOARG = "Mo'arg";
	D_CORE_HOUND = "Core hound";
	D_INFERNAL = "Infernal";
	D_ABYSSAL = "Abyssal";
	D_DOOMGUARD = "Doomguard";
	D_FIEND = "Fiend";
	D_PIT_LORD = "Pit lord";
	D_EREDAR = "Eredar";
	D_NIGHTMARE = "Nightmare";
	D_UNKNOWN = "Unknown";
	D_INFSOUL = "Soul";
	D_GARGOYLE = "Gargoyle";
	D_ARMORWALKER = "Fel voidwalker";

elseif GetLocale() == "zhTW" then
	D_DEMON = "惡魔"
	Immune_Call = "Demon is Inmune to Enslave!"
	New_Tracked = "New demon tracked!"
	No_Pet = "You don't have a pet"
	Already_Known = "Already known"
	Immune_to_Enslave = "Immune to Enslave"
	Can_be_Enslaved = "Can be Enslaved"
	Unknown_to_Enslave = "Unknown"
	D_CONFIRM = "Are you sure?"
	D_SUCCUBUS = "Succubus";
	D_FELGUARD = "Felguard";
	D_DREADLORD = "Dreadlord";
	D_IMP = "Imp";
	D_SHIVAN = "Shivan";
	D_WRATHGUARD = "Wrathguard";
	D_VOIDWALKER = "Voidwalker";
	D_VOID_TERROR = "Void terror";
	D_FELHOUND = "Felhound";
	D_BOAR = "Helboar";
	D_VOIDWRAITH = "Voidwraith";
	D_OUTLANDSIMP = "Fel imp";
	D_DARKHOUND = "Dark hound";
	D_SATYR = "Satyr";
	D_BEHOLDER = "Beholder";
	D_GANARG = "Gan'arg";
	D_MOARG = "Mo'arg";
	D_CORE_HOUND = "Core hound";
	D_INFERNAL = "Infernal";
	D_ABYSSAL = "Abyssal";
	D_DOOMGUARD = "Doomguard";
	D_FIEND = "Fiend";
	D_PIT_LORD = "Pit lord";
	D_EREDAR = "Eredar";
	D_NIGHTMARE = "Nightmare";
	D_UNKNOWN = "Unknown";
	D_INFSOUL = "Soul";
	D_GARGOYLE = "Gargoyle";
	D_ARMORWALKER = "Fel voidwalker";

else
	D_DEMON = "Demon"
	Immune_Call = "Demon is Inmune to Enslave!"
	New_Tracked = "New demon tracked!"
	No_Pet = "You don't have a pet"
	Already_Known = "Already known"
	Immune_to_Enslave = "Immune to Enslave"
	Can_be_Enslaved = "Can be Enslaved"
	Unknown_to_Enslave = "Unknown"
	D_CONFIRM = "Are you sure?"
	D_SUCCUBUS = "Succubus";
	D_FELGUARD = "Felguard";
	D_DREADLORD = "Dreadlord";
	D_IMP = "Imp";
	D_SHIVAN = "Shivan";
	D_WRATHGUARD = "Wrathguard";
	D_VOIDWALKER = "Voidwalker";
	D_VOID_TERROR = "Void terror";
	D_FELHOUND = "Felhound";
	D_BOAR = "Helboar";
	D_VOIDWRAITH = "Voidwraith";
	D_OUTLANDSIMP = "Fel imp";
	D_DARKHOUND = "Dark hound";
	D_SATYR = "Satyr";
	D_BEHOLDER = "Beholder";
	D_GANARG = "Gan'arg";
	D_MOARG = "Mo'arg";
	D_CORE_HOUND = "Core hound";
	D_INFERNAL = "Infernal";
	D_ABYSSAL = "Abyssal";
	D_DOOMGUARD = "Doomguard";
	D_FIEND = "Fiend";
	D_PIT_LORD = "Pit lord";
	D_EREDAR = "Eredar";
	D_NIGHTMARE = "Nightmare";
	D_UNKNOWN = "Unknown";
	D_INFSOUL = "Soul";
	D_GARGOYLE = "Gargoyle";
	D_ARMORWALKER = "Fel voidwalker";	
end

function DemonListFrame_OnLoad()

	DemonListScrollFrame:Show();
	DemonListFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
	DemonListFrame:RegisterEvent("UNIT_MODEL_CHANGED");
	out("Grimoire of a Thousand Souls loaded successfully");
	SLASH_GOATS1 = "/goats";
	SLASH_GOATS2 = "/GOATS";
	SlashCmdList["GOATS"] = function(msg)
		GOATS_SlashCommandHandler(msg);
	end

	DemonListFrame:SetAttribute("UIPanelLayout-defined", true)
	DemonListFrame:SetAttribute("UIPanelLayout-enabled", true)
	DemonListFrame:SetAttribute("UIPanelLayout-area", "left")
	DemonListFrame:SetAttribute("UIPanelLayout-pushable", 9)
	DemonListFrame:SetAttribute("UIPanelLayout-width", 384)
	DemonListFrame:SetAttribute("UIPanelLayout-whileDead", true)

end

function out(text)
 DEFAULT_CHAT_FRAME:AddMessage(text)
-- UIErrorsFrame:AddMessage(text, 1.0, 1.0, 0, 1, 10) 
end

function GOATS_SlashCommandHandler(msg)
	if (msg == "wipe") then
		wipe(DNAMES); wipe(DLEVELS); wipe(DARMORS); wipe(DHEALTHS); wipe(DMANAS);
		wipe(DSTAT1S); wipe(DSTAT2S); wipe(DSTAT3S); wipe(DSTAT4S); wipe(DSTAT5S);
		wipe(DATPOWERS); wipe(DPERCENTS); wipe(CritChanceFromAgilitys); wipe(UnitHealthModifiers); wipe(UnitMaxHealthModifiers); 
		wipe(UnitPowerModifiers); wipe(SpellCritChanceFromIntellects); wipe(UnitManaRegenRateFromSpirits); 
		wipe(DELITES); wipe(DZONES); wipe(DCOORDXS); wipe(DCOORDYS); wipe(DZONEINDEXS);
		wipe(DCONTINENTINDEXS); wipe(SKILLNAME1S); wipe(SKILLSUBTEXT1S); wipe(SKILLTEXTURE1S);
		wipe(SKILLID1S); wipe(SKILLNAME2S); wipe(SKILLSUBTEXT2S); wipe(SKILLTEXTURE2S); 
		wipe(SKILLID2S); wipe(SKILLNAME3S); wipe(SKILLSUBTEXT3S); wipe(SKILLTEXTURE3S); 
		wipe(SKILLID3S); wipe(SKILLNAME4S); wipe(SKILLSUBTEXT4S); wipe(SKILLTEXTURE4S); 
		wipe(SKILLID4S); wipe(RaceListDatabase); wipe(DCOMMENTS); wipe(RES1); wipe(RES2); wipe(RES3);
		wipe(RES4); wipe(RES5); wipe(DMINDMGS); wipe(DMAXDMGS); wipe(DMINODMGS); wipe(DMAXODMGS); 
		wipe(DSPEEDS); wipe(DOSPEEDS); wipe(IMMUNES);
		UIErrorsFrame:AddMessage("|c00FF6600GOATS:|r Database wiped!", 1.0, 1.0, 0, 1, 10);
		DemonDataFrame:Hide();
		DemonListFrameTotals:SetText(format(ERR_ZONE_EXPLORED, GOATS_tcount(DNAMES)));
		DemonListScrollFrame_Update()
	elseif (msg == "model") then
		UIErrorsFrame:AddMessage("Path: "..DemonModelFrame:GetModel().."\n x: "..Dx..", y: "..Dy..", z: "..Dz.."\n Scale: "..DSize, 1.0, 1.0, 0, 1, 10);
		if (DemonModelFrame:GetModel() == "creature\\felboar\\felboar.m2") then
			out("OMG, a felboar!")
		end
	else
 	GOATS_Toggle(msg);
	end
end

function GOATS_Toggle(msg)
   local frame = _G["DemonListFrame"]
   if (frame) then
   	if(  frame:IsVisible() ) then
      	--	frame:Hide();
		HideUIPanel(frame)
		StaticPopup_Hide ("GOATS_Confirm_Dialog")
   	else
     	--	frame:Show();
		ShowUIPanel(frame)
   	end
   end
end

function DemonListCheckButton_OnClick()
   local frame = _G["DemonDataFrame"]
   if (frame) then
   	if(  frame:IsVisible() ) then
     	--	DemonDataSetData();
      		DemonPortraitFrame:Show();
		DemonSkillFrame:Show();
		DemonModelFrame:Hide();
		DemonDataFrameAppearanceButton:Show();
   	else
     		frame:Show();
      		DemonPortraitFrame:Show();
		DemonSkillFrame:Show();
		DemonModelFrame:Hide();
		DemonDataFrameAppearanceButton:Show();
   	end
   end
end

function DemonListAppearanceButton_OnClick()
   local portrait = _G["DemonPortraitFrame"];
   local skill = _G["DemonSkillFrame"];
   local dmodel = _G["DemonModelFrame"];
   if (portrait) then
--	if(  portrait:IsVisible() ) then
      		portrait:Hide();
		skill:Hide();
	--	GOATS_setModel();
		dmodel:Show();
		GOATS_ShowModel();
		DemonDataFrameAppearanceButton:Hide();
--	end
   end
end

function DemonListFavButton_OnClick()
   local frame = _G["DemonDataFrame"]
   if (frame) then
   	if(  frame:IsVisible() ) then
      		DemonDataFrame_Update();
   	else
     		frame:Show();
   	end
   end
end

function DemonListDeleteButton_OnClick()
   local frame = _G["DemonListFrame"]
   if (frame) then
   	if(  frame:IsVisible() ) then
      		GOATS_tremovebyvalindex(DNAMES, SelectedDemonName);
		DemonListFrameTotals:SetText(format(ERR_ZONE_EXPLORED, GOATS_tcount(DNAMES)));
		DemonListScrollFrame_Update()
				DemonListFrameFavButton:Disable();
				DemonListCheckButton:Disable();
				DemonListDeleteButton:Disable();
				DemonDataFrame:Hide();
				SelectedDemon = nil
   	else
     		 frame:Show();
   	end
   end
end

function GOATS_tremovebyvalindex(tab, val)
	for k,v in pairs(tab) do
		if(v==val) then
			table.remove(tab, k);
			table.remove(DLEVELS, k);
			table.remove(DARMORS, k);
			table.remove(DHEALTHS, k);
			table.remove(DMANAS, k);
			table.remove(DSTAT1S, k);
			table.remove(DSTAT2S, k);
			table.remove(DSTAT3S, k);
			table.remove(DSTAT4S, k);
			table.remove(DSTAT5S, k);
			table.remove(DATPOWERS, k);
			table.remove(DPERCENTS, k);
			table.remove(DZONES, k);
			table.remove(DZONEINDEXS, k);
			table.remove(DCONTINENTINDEXS, k);
			table.remove(DCOORDXS, k);
			table.remove(DCOORDYS, k);
			table.remove(CritChanceFromAgilitys, k);
			table.remove(UnitHealthModifiers, k);
			table.remove(UnitMaxHealthModifiers, k);
			table.remove(UnitPowerModifiers, k);
			table.remove(SpellCritChanceFromIntellects, k);
		--	table.remove(UnitHealthRegenRateFromSpirits, k);
			table.remove(UnitManaRegenRateFromSpirits, k);
			table.remove(DELITES, k);
			table.remove(DCOMMENTS, k);
			table.remove(SKILLNAME1S, k);
			table.remove(SKILLSUBTEXT1S, k);
			table.remove(SKILLTEXTURE1S, k);
			table.remove(SKILLID1S, k);
			table.remove(SKILLNAME2S, k);
			table.remove(SKILLSUBTEXT2S, k);
			table.remove(SKILLTEXTURE2S, k);
			table.remove(SKILLID2S, k);
			table.remove(SKILLNAME3S, k);
			table.remove(SKILLSUBTEXT3S, k);
			table.remove(SKILLTEXTURE3S, k);
			table.remove(SKILLID3S, k);
			table.remove(SKILLNAME4S, k);
			table.remove(SKILLSUBTEXT4S, k);
			table.remove(SKILLTEXTURE4S, k);
			table.remove(SKILLID4S, k);
			table.remove(RaceListDatabase, k);
			table.remove(RES1, k);
			table.remove(RES2, k);
			table.remove(RES3, k);
			table.remove(RES4, k);
			table.remove(RES5, k);
			table.remove(DMINDMGS, k);
			table.remove(DMAXDMGS, k);
			table.remove(DMINODMGS, k);
			table.remove(DMAXODMGS, k);
			table.remove(DSPEEDS, k);
			table.remove(DOSPEEDS, k);
			return true;
		end
	end
	return false;
end

function DemonListScrollFrame_Update()
	local Dbutton;
	local lineplusoffset;
	local DemonOffset = FauxScrollFrame_GetOffset(DemonListScrollFrame);

	for line=1,DEMONS_TO_DISPLAY, 1 do
		lineplusoffset = DemonOffset + line;
		Dbutton = _G["DemonTitleButton"..line];
		Dbutton.lineplusoffset = lineplusoffset;

		if ( SelectedDemon == lineplusoffset ) then
			_G["DemonTitleButton"..line]:LockHighlight();
		else
			_G["DemonTitleButton"..line]:UnlockHighlight();
		end

		if lineplusoffset <= GOATS_tcount(DNAMES) then
			_G["DemonTitleButton"..line.."Elite"]:SetText(DELITES[lineplusoffset]);
			_G["DemonTitleButton"..line.."Comment"]:SetText(DCOMMENTS[lineplusoffset]);

			if (_G["DemonTitleButton"..line.."Elite"]:GetText() == "elite") and not ( _G["DemonTitleButton"..line.."Comment"]:GetText() == "??") then
				_G["DemonTitleButton"..line.."ColoredName"]:SetText(DNAMES[lineplusoffset]);
				_G["DemonTitleButton"..line.."ColoredName"]:SetTextColor(GOATS_Colors.CommentedElite.R, GOATS_Colors.CommentedElite.G, GOATS_Colors.CommentedElite.B)
			elseif (_G["DemonTitleButton"..line.."Elite"]:GetText() == "elite") then
				_G["DemonTitleButton"..line.."ColoredName"]:SetText(DNAMES[lineplusoffset]);
				_G["DemonTitleButton"..line.."ColoredName"]:SetTextColor(GOATS_Colors.Elite.R, GOATS_Colors.Elite.G, GOATS_Colors.Elite.B)
			elseif (_G["DemonTitleButton"..line.."Comment"]:GetText() == "??") then
				_G["DemonTitleButton"..line.."ColoredName"]:SetText(DNAMES[lineplusoffset]);
				_G["DemonTitleButton"..line.."ColoredName"]:SetTextColor(GOATS_Colors.Normal.R, GOATS_Colors.Normal.G, GOATS_Colors.Normal.B)
			else
				_G["DemonTitleButton"..line.."ColoredName"]:SetText(DNAMES[lineplusoffset]);
				_G["DemonTitleButton"..line.."ColoredName"]:SetTextColor(GOATS_Colors.Commented.R, GOATS_Colors.Commented.G, GOATS_Colors.Commented.B)
			end
			_G["DemonTitleButton"..line.."Name"]:SetText(DNAMES[lineplusoffset]);
			_G["DemonTitleButton"..line.."Zone"]:SetText(DZONES[lineplusoffset]);
			_G["DemonTitleButton"..line.."Level"]:SetText(DLEVELS[lineplusoffset]);
			_G["DemonTitleButton"..line.."Race"]:SetText(RaceListDatabase[lineplusoffset]);
			_G["DemonTitleButton"..line.."Armor"]:SetText(DARMORS[lineplusoffset]);
			_G["DemonTitleButton"..line.."Health"]:SetText(DHEALTHS[lineplusoffset]);
			_G["DemonTitleButton"..line.."Mana"]:SetText(DMANAS[lineplusoffset]);
			_G["DemonTitleButton"..line.."Stat1"]:SetText(DSTAT1S[lineplusoffset]);
			_G["DemonTitleButton"..line.."Stat2"]:SetText(DSTAT2S[lineplusoffset]);
			_G["DemonTitleButton"..line.."Stat3"]:SetText(DSTAT3S[lineplusoffset]);
			_G["DemonTitleButton"..line.."Stat4"]:SetText(DSTAT4S[lineplusoffset]);
			_G["DemonTitleButton"..line.."Stat5"]:SetText(DSTAT5S[lineplusoffset]);
			_G["DemonTitleButton"..line.."AtPower"]:SetText(DATPOWERS[lineplusoffset]);
			_G["DemonTitleButton"..line.."ZoneIndex"]:SetText(DZONEINDEXS[lineplusoffset]);
			_G["DemonTitleButton"..line.."ContinentIndex"]:SetText(DCONTINENTINDEXS[lineplusoffset]);
			_G["DemonTitleButton"..line.."CoordX"]:SetText(DCOORDXS[lineplusoffset]);
			_G["DemonTitleButton"..line.."CoordY"]:SetText(DCOORDYS[lineplusoffset]);
			_G["DemonTitleButton"..line.."Damage"]:SetText(DPERCENTS[lineplusoffset]);
			_G["DemonTitleButton"..line.."MinDamage"]:SetText(DMINDMGS[lineplusoffset]);
			_G["DemonTitleButton"..line.."MaxDamage"]:SetText(DMAXDMGS[lineplusoffset]);
			_G["DemonTitleButton"..line.."MinOHDamage"]:SetText(DMINODMGS[lineplusoffset]);
			_G["DemonTitleButton"..line.."MaxOHDamage"]:SetText(DMAXODMGS[lineplusoffset]);
			_G["DemonTitleButton"..line.."Speed"]:SetText(DSPEEDS[lineplusoffset]);
			_G["DemonTitleButton"..line.."OHSpeed"]:SetText(DOSPEEDS[lineplusoffset]);
			_G["DemonTitleButton"..line.."CritChanceFromAgility"]:SetText(CritChanceFromAgilitys[lineplusoffset]);
			_G["DemonTitleButton"..line.."UnitHealthModifier"]:SetText(UnitHealthModifiers[lineplusoffset]);
			_G["DemonTitleButton"..line.."UnitMaxHealthModifier"]:SetText(UnitMaxHealthModifiers[lineplusoffset]);
			_G["DemonTitleButton"..line.."UnitPowerModifier"]:SetText(UnitPowerModifiers[lineplusoffset]);
			_G["DemonTitleButton"..line.."SpellCritChanceFromIntellect"]:SetText(SpellCritChanceFromIntellects[lineplusoffset]);
		--	_G["DemonTitleButton"..line.."UnitHealthRegenRateFromSpirit"]:SetText(UnitHealthRegenRateFromSpirits[lineplusoffset]);
			_G["DemonTitleButton"..line.."UnitManaRegenRateFromSpirit"]:SetText(UnitManaRegenRateFromSpirits[lineplusoffset]);

			_G["DemonTitleButton"..line.."1SkillName"]:SetText(SKILLNAME1S[lineplusoffset]);
			_G["DemonTitleButton"..line.."1SkillSubText"]:SetText(SKILLSUBTEXT1S[lineplusoffset]);
			_G["DemonTitleButton"..line.."1SkillTexture"]:SetText(SKILLTEXTURE1S[lineplusoffset]);
			_G["DemonTitleButton"..line.."1SkillId"]:SetText(SKILLID1S[lineplusoffset]);
			_G["DemonTitleButton"..line.."2SkillName"]:SetText(SKILLNAME2S[lineplusoffset]);
			_G["DemonTitleButton"..line.."2SkillSubText"]:SetText(SKILLSUBTEXT2S[lineplusoffset]);
			_G["DemonTitleButton"..line.."2SkillTexture"]:SetText(SKILLTEXTURE2S[lineplusoffset]);
			_G["DemonTitleButton"..line.."2SkillId"]:SetText(SKILLID2S[lineplusoffset]);
			_G["DemonTitleButton"..line.."3SkillName"]:SetText(SKILLNAME3S[lineplusoffset]);
			_G["DemonTitleButton"..line.."3SkillSubText"]:SetText(SKILLSUBTEXT3S[lineplusoffset]);
			_G["DemonTitleButton"..line.."3SkillTexture"]:SetText(SKILLTEXTURE3S[lineplusoffset]);
			_G["DemonTitleButton"..line.."3SkillId"]:SetText(SKILLID3S[lineplusoffset]);
			_G["DemonTitleButton"..line.."4SkillName"]:SetText(SKILLNAME4S[lineplusoffset]);
			_G["DemonTitleButton"..line.."4SkillSubText"]:SetText(SKILLSUBTEXT4S[lineplusoffset]);
			_G["DemonTitleButton"..line.."4SkillTexture"]:SetText(SKILLTEXTURE4S[lineplusoffset]);
			_G["DemonTitleButton"..line.."4SkillId"]:SetText(SKILLID4S[lineplusoffset]);

			_G["DemonTitleButton"..line]:Show();

		else
			_G["DemonTitleButton"..line]:Hide();
		end

		if ( not SelectedDemon ) then
			DemonListFrameFavButton:Disable();
			DemonListCheckButton:Disable();
			DemonListDeleteButton:Disable();
		else
			DemonListFrameFavButton:Enable();
			DemonListCheckButton:Enable();
			DemonListDeleteButton:Enable();
		end

		--DemonFrame_SetResistances()
		FauxScrollFrame_Update(DemonListScrollFrame,GOATS_tcount(DNAMES), DEMONS_TO_DISPLAY, DLIST_FRAME_DEMON_HEIGHT);
	end
end

function DemonListButton_OnClick(self, button)
	if ( button == "LeftButton" ) then
		SelectedDemon = _G["DemonTitleButton"..self:GetID()].lineplusoffset;
		SelectedDemonName = _G["DemonTitleButton"..self:GetID().."Name"]:GetText();
		SelectedDemonColoredName = _G["DemonTitleButton"..self:GetID().."ColoredName"]:GetText();
		SelectedDemonZone = _G["DemonTitleButton"..self:GetID().."Zone"]:GetText();
		SelectedDemonLevel = _G["DemonTitleButton"..self:GetID().."Level"]:GetText();
		SelectedDemonRace = _G["DemonTitleButton"..self:GetID().."Race"]:GetText();
		SelectedDemonArmor = _G["DemonTitleButton"..self:GetID().."Armor"]:GetText();
		SelectedDemonHealth = _G["DemonTitleButton"..self:GetID().."Health"]:GetText();
		SelectedDemonMana = _G["DemonTitleButton"..self:GetID().."Mana"]:GetText();
		SelectedDemonStat1 = _G["DemonTitleButton"..self:GetID().."Stat1"]:GetText();
		SelectedDemonStat2 = _G["DemonTitleButton"..self:GetID().."Stat2"]:GetText();
		SelectedDemonStat3 = _G["DemonTitleButton"..self:GetID().."Stat3"]:GetText();
		SelectedDemonStat4 = _G["DemonTitleButton"..self:GetID().."Stat4"]:GetText();
		SelectedDemonStat5 = _G["DemonTitleButton"..self:GetID().."Stat5"]:GetText();
		SelectedDemonAtPower = _G["DemonTitleButton"..self:GetID().."AtPower"]:GetText();
		SelectedDemonElite = _G["DemonTitleButton"..self:GetID().."Elite"]:GetText();
		SelectedDemonComment = _G["DemonTitleButton"..self:GetID().."Comment"]:GetText();
		SelectedDemonZoneIndex = _G["DemonTitleButton"..self:GetID().."ZoneIndex"]:GetText();
		SelectedDemonContinentIndex = _G["DemonTitleButton"..self:GetID().."ContinentIndex"]:GetText();
		SelectedDemonCoordX = _G["DemonTitleButton"..self:GetID().."CoordX"]:GetText();
		SelectedDemonCoordY = _G["DemonTitleButton"..self:GetID().."CoordY"]:GetText();
		SelectedDemonZone = _G["DemonTitleButton"..self:GetID().."Zone"]:GetText();
		SelectedDemonPercent = _G["DemonTitleButton"..self:GetID().."Damage"]:GetText();
		SelectedDemonMinDamage = _G["DemonTitleButton"..self:GetID().."MinDamage"]:GetText();
		SelectedDemonMaxDamage = _G["DemonTitleButton"..self:GetID().."MaxDamage"]:GetText();
		SelectedDemonMinOHDamage = _G["DemonTitleButton"..self:GetID().."MinOHDamage"]:GetText();
		SelectedDemonMaxOHDamage = _G["DemonTitleButton"..self:GetID().."MaxOHDamage"]:GetText();
		SelectedDemonSpeed = _G["DemonTitleButton"..self:GetID().."Speed"]:GetText();
		SelectedDemonOHSpeed = _G["DemonTitleButton"..self:GetID().."OHSpeed"]:GetText();
		SelectedDemonCritChanceFromAgility = _G["DemonTitleButton"..self:GetID().."CritChanceFromAgility"]:GetText();
		SelectedDemonUnitHealthModifier = _G["DemonTitleButton"..self:GetID().."UnitHealthModifier"]:GetText();
		SelectedDemonUnitMaxHealthModifier = _G["DemonTitleButton"..self:GetID().."UnitMaxHealthModifier"]:GetText();
		SelectedDemonUnitPowerModifier = _G["DemonTitleButton"..self:GetID().."UnitPowerModifier"]:GetText();
		SelectedDemonSpellCritChanceFromIntellect = _G["DemonTitleButton"..self:GetID().."SpellCritChanceFromIntellect"]:GetText();
	--	SelectedDemonUnitHealthRegenRateFromSpirit = _G["DemonTitleButton"..self:GetID().."UnitHealthRegenRateFromSpirit"]:GetText();
		SelectedDemonUnitManaRegenRateFromSpirit = _G["DemonTitleButton"..self:GetID().."UnitManaRegenRateFromSpirit"]:GetText();

		SelectedDemonSkill1Name = _G["DemonTitleButton"..self:GetID().."1SkillName"]:GetText();
		SelectedDemonSkill1SubText = _G["DemonTitleButton"..self:GetID().."1SkillSubText"]:GetText();
		SelectedDemonSkill1Texture = _G["DemonTitleButton"..self:GetID().."1SkillTexture"]:GetText();
		SelectedDemonSkill1Id = _G["DemonTitleButton"..self:GetID().."1SkillId"]:GetText();
		SelectedDemonSkill2Name = _G["DemonTitleButton"..self:GetID().."2SkillName"]:GetText();
		SelectedDemonSkill2SubText = _G["DemonTitleButton"..self:GetID().."2SkillSubText"]:GetText();
		SelectedDemonSkill2Texture = _G["DemonTitleButton"..self:GetID().."2SkillTexture"]:GetText();
		SelectedDemonSkill2Id = _G["DemonTitleButton"..self:GetID().."2SkillId"]:GetText();
		SelectedDemonSkill3Name = _G["DemonTitleButton"..self:GetID().."3SkillName"]:GetText();
		SelectedDemonSkill3SubText = _G["DemonTitleButton"..self:GetID().."3SkillSubText"]:GetText();
		SelectedDemonSkill3Texture = _G["DemonTitleButton"..self:GetID().."3SkillTexture"]:GetText();
		SelectedDemonSkill3Id = _G["DemonTitleButton"..self:GetID().."3SkillId"]:GetText();
		SelectedDemonSkill4Name = _G["DemonTitleButton"..self:GetID().."4SkillName"]:GetText();
		SelectedDemonSkill4SubText = _G["DemonTitleButton"..self:GetID().."4SkillSubText"]:GetText();
		SelectedDemonSkill4Texture = _G["DemonTitleButton"..self:GetID().."4SkillTexture"]:GetText();
		SelectedDemonSkill4Id = _G["DemonTitleButton"..self:GetID().."4SkillId"]:GetText();

		for trick=1,DEMONS_TO_DISPLAY do
			local trickplusoffset = trick + FauxScrollFrame_GetOffset(DemonListScrollFrame);
			button = _G["DemonTitleButton"..trick];
			button.trickplusoffset = trickplusoffset;



		--	if ( SelectedDemon == trick ) then
		--		button:LockHighlight();
		--	else
		--		button:UnlockHighlight();
		--	end

		--	if ( not SelectedDemon ) then
		--		DemonListFrameFavButton:Disable();
		--		DemonListCheckButton:Disable();
		--		DemonListDeleteButton:Disable();
		--	else
		--		DemonListFrameFavButton:Enable();
		--		DemonListCheckButton:Enable();
		--		DemonListDeleteButton:Enable();
		--	end
		end

		DemonListScrollFrame_Update()
		DemonDataSetData();
		if WorldMapFrame:IsVisible() then
			DemonMapDisplay();
		end
		if DemonModelFrame:IsVisible() then
		--	DemonListCheckButton_OnClick()
			DemonListAppearanceButton_OnClick()
		end
	end
end

function DemonDataSetPortrait()
local P_RACE;
	if ( _G["SelectedDemonRace"] == D_GARGOYLE ) then
		P_RACE = "Interface\\Icons\\Ability_Hunter_Pet_Bat";
	elseif ( _G["SelectedDemonRace"] == D_VOIDWRAITH ) then
		P_RACE = "Interface\\Addons\\GOATS\\textures\\Icons\\voidwraith.tga";
	elseif ( _G["SelectedDemonRace"] == D_SUCCUBUS ) then
		P_RACE = "Interface\\Icons\\Spell_Shadow_SummonSuccubus";
	elseif ( _G["SelectedDemonRace"] == D_FELGUARD ) then
		P_RACE = "Interface\\Icons\\Spell_Shadow_DemonicPact";
	elseif ( _G["SelectedDemonRace"] == D_DREADLORD ) then
		P_RACE = "Interface\\Addons\\GOATS\\textures\\Icons\\dreadlord.tga";
	elseif ( _G["SelectedDemonRace"] == D_IMP ) then
		P_RACE = "Interface\\Icons\\Spell_Shadow_SummonImp";
	elseif ( _G["SelectedDemonRace"] == D_SHIVAN ) then
		P_RACE = "Interface\\Addons\\GOATS\\textures\\Icons\\shivan.tga";
	elseif ( _G["SelectedDemonRace"] == D_WRATHGUARD ) then
		P_RACE = "Interface\\Addons\\GOATS\\textures\\Icons\\wrathguard.tga";
	elseif ( _G["SelectedDemonRace"] == D_VOIDWALKER ) then
		P_RACE = "Interface\\Icons\\Spell_Shadow_SummonVoidWalker";
	elseif ( _G["SelectedDemonRace"] == D_VOID_TERROR ) then
		P_RACE = "Interface\\Addons\\GOATS\\textures\\Icons\\voidterror.tga";
	elseif ( _G["SelectedDemonRace"] == D_FELHOUND ) then
		P_RACE = "Interface\\Icons\\Spell_Shadow_SummonFelHunter";
	elseif ( _G["SelectedDemonRace"] == D_BOAR ) then
		P_RACE = "Interface\\Addons\\GOATS\\textures\\Icons\\boar.tga";
	elseif ( _G["SelectedDemonRace"] == D_OUTLANDSIMP ) then
		P_RACE = "Interface\\Icons\\Ability_Warlock_EmpoweredImp";
	elseif ( _G["SelectedDemonRace"] == D_DARKHOUND ) then
		P_RACE = "Interface\\Addons\\GOATS\\textures\\Icons\\darkhonud.tga";
	elseif ( _G["SelectedDemonRace"] == D_SATYR ) then
		P_RACE = "Interface\\Addons\\GOATS\\textures\\Icons\\satyr.tga";
	elseif ( _G["SelectedDemonRace"] == D_BEHOLDER ) then
		P_RACE = "Interface\\Addons\\GOATS\\textures\\Icons\\beholder.tga";
	elseif ( _G["SelectedDemonRace"] == D_GANARG ) then
		P_RACE = "Interface\\Addons\\GOATS\\textures\\Icons\\Ganarg.tga";
	elseif ( _G["SelectedDemonRace"] == D_MOARG ) then
		P_RACE = "Interface\\Addons\\GOATS\\textures\\Icons\\Moarg.tga";
	elseif ( _G["SelectedDemonRace"] == D_CORE_HOUND ) then
		P_RACE = "Interface\\Icons\\Ability_Hunter_Pet_CoreHound";
	elseif ( _G["SelectedDemonRace"] == D_INFERNAL ) then
		P_RACE = "Interface\\Icons\\Spell_Shadow_SummonInfernal";
	elseif ( _G["SelectedDemonRace"] == D_ABYSSAL ) then
		P_RACE = "Interface\\Addons\\GOATS\\textures\\Icons\\abyssal.tga";
	elseif ( _G["SelectedDemonRace"] == D_DOOMGUARD ) then
		P_RACE = "Interface\\Addons\\GOATS\\textures\\Icons\\Doomguard.tga";
	elseif ( _G["SelectedDemonRace"] == D_FIEND ) then
		P_RACE = "Interface\\Icons\\Achievement_Boss_OmarTheUnscarred_01";
	elseif ( _G["SelectedDemonRace"] == D_PIT_LORD ) then
		P_RACE = "Interface\\Icons\\Achievement_Boss_Magtheridon";
	elseif ( _G["SelectedDemonRace"] == D_EREDAR ) then
		P_RACE = "Interface\\Icons\\Achievement_Boss_PrinceMalchezaar_02";
	elseif ( _G["SelectedDemonRace"] == D_NIGHTMARE ) then
		P_RACE = "Interface\\Icons\\Quest_12252_Icon";
	elseif ( _G["SelectedDemonRace"] == D_INFSOUL ) then
		P_RACE = "Interface\\Addons\\GOATS\\textures\\Icons\\FelFire_Elemental.tga";
	elseif ( _G["SelectedDemonRace"] == D_ARMORWALKER ) then
		P_RACE = "Interface\\Icons\\Achievement_Boss_Zuramat";
	else
		P_RACE = "Interface\\Icons\\Spell_Shadow_CurseOfTounges";
	end
	_G["DemonPortraitTexture"]:SetTexture(P_RACE);
end

function DemonDataSetData()
	_G["DemonDataNameText"]:SetText(SelectedDemonName);
	_G["DemonLevelText"]:SetFormattedText(UNIT_TYPE_LEVEL_TEMPLATE,_G["SelectedDemonLevel"],_G["SelectedDemonRace"]);
	_G["DemonDataHealthText"]:SetText(HEALTH_COLON.." |c00FFFFFF"..SelectedDemonHealth.."|r");
	_G["DemonDataManaText"]:SetText(MANA_COLON.." |c00FFFFFF"..SelectedDemonMana.."|r");

--	GOATS_setModel();
	DemonDataSetPortrait();
	DemonDataSetArmor();
	DemonDataSetStats();
	DemonDataSetSpellBonus();
	DemonDataSetAttackPower();
	DemonDataSetDamage();
	DemonDataSetElite();
	DemonDataSetSkills();
	DemonFrame_SetResistances();
	if (SelectedDemonComment == "??") then
		DemonPortraitFrameComment:Hide();
	else
		DemonPortraitFrameComment:Show();
	end
end


function DemonMapDisplay()
--	UIErrorsFrame:AddMessage("|c00FF6600GOATS:|r Map shown!", 1.0, 1.0, 0, 1, 10);
	ShowUIPanel(WorldMapFrame);
--	SetMapZoom(_G["SelectedDemonContinentIndex"], _G["SelectedDemonZoneIndex"]);

	SetMapByID(_G["SelectedDemonZoneIndex"]);
	if (_G["SelectedDemonContinentIndex"] == "NoInstance") then
		--No instance!!
	else
		SetDungeonMapLevel(_G["SelectedDemonContinentIndex"]);
	end

	SetMapMark();

end

function SetMapMark()
	if (SelectedDemonElite == "elite") then
		_G["MapIconElite"]:Show();
		if ( WORLDMAP_SETTINGS.size == WORLDMAP_WINDOWED_SIZE ) then
		--	_G["MapIconElite"]:SetPoint("CENTER", "WorldMapButton", "TOPLEFT", SelectedDemonCoordX*520, SelectedDemonCoordY*-342);
			_G["MapIconElite"]:SetPoint("CENTER", "WorldMapButton", "TOPLEFT", SelectedDemonCoordX*WorldMapButton:GetWidth()/2, SelectedDemonCoordY*-1*WorldMapButton:GetHeight()/2);
		else
		--	_G["MapIconElite"]:SetPoint("CENTER", "WorldMapButton", "TOPLEFT", SelectedDemonCoordX*WorldMapButton:GetWidth(), SelectedDemonCoordY*-1*WorldMapButton:GetHeight());
			_G["MapIconElite"]:SetPoint("CENTER", "WorldMapButton", "TOPLEFT", SelectedDemonCoordX*WorldMapButton:GetHeight()/2, SelectedDemonCoordY*-1*WorldMapButton:GetHeight()/2);
		end
	else
		_G["MapIconNormal"]:Show();
		if ( WORLDMAP_SETTINGS.size == WORLDMAP_WINDOWED_SIZE ) then
			_G["MapIconNormal"]:SetPoint("CENTER", "WorldMapButton", "TOPLEFT", SelectedDemonCoordX*WorldMapButton:GetWidth()/2, SelectedDemonCoordY*-1*WorldMapButton:GetHeight()/2);
		else
			_G["MapIconNormal"]:SetPoint("CENTER", "WorldMapButton", "TOPLEFT", SelectedDemonCoordX*WorldMapButton:GetHeight()/2, SelectedDemonCoordY*-1*WorldMapButton:GetHeight()/2);
		end
	end
	MapIconNormal:SetFrameLevel(150);
	MapIconElite:SetFrameLevel(150);
end

function DemonDataSetElite()
	local eliteframe = _G["DemonElite"]
	if ((SelectedDemonElite == "elite") or (SelectedDemonElite == "worldboss")) then
		_G["DemonPortraitBG"]:Hide();
		eliteframe:Show();
	else
		_G["DemonPortraitBG"]:Show();
		eliteframe:Hide();
	end
end

function DemonDataSetAttackPower()
	_G["DemonAttackPowerFrameLabel"]:SetText(format(STAT_FORMAT, ATTACK_POWER));
	local text = _G["DemonAttackPowerFrameStatText"];
	local base = _G["SelectedDemonAtPower"];
	local posBuff, negBuff = 0, 0

	text:SetText(_G["SelectedDemonAtPower"])

	PaperDollFormatStat(MELEE_ATTACK_POWER, base, posBuff, negBuff, DemonAttackPowerFrame, text);
	DemonAttackPowerFrame.tooltip2 = format(MELEE_ATTACK_POWER_TOOLTIP, max((base+posBuff+negBuff), 0)/ATTACK_POWER_MAGIC_NUMBER);
	DemonAttackPowerFrame:Show();
end

function DemonDataSetSpellBonus()
	local spellDamageBonus = GetPetSpellBonusDamage();
	local spellDamageBonusText = format("%d",spellDamageBonus);

	DemonSpellDamageFrameLabel:SetText(format(STAT_FORMAT, SPELL_BONUS));
	if ( spellDamageBonus > 0 ) then
		spellDamageBonusText = GREEN_FONT_COLOR_CODE.."+"..spellDamageBonusText..FONT_COLOR_CODE_CLOSE;
	elseif( spellDamageBonus < 0 ) then
		spellDamageBonusText = RED_FONT_COLOR_CODE..spellDamageBonusText..FONT_COLOR_CODE_CLOSE;
	end

	DemonSpellDamageFrameStatText:SetText(spellDamageBonusText);
	DemonSpellDamageFrame.tooltip = HIGHLIGHT_FONT_COLOR_CODE..format(PAPERDOLLFRAME_TOOLTIP_FORMAT, SPELL_BONUS)..FONT_COLOR_CODE_CLOSE.." "..spellDamageBonusText;
	DemonSpellDamageFrame.tooltip2 = DEFAULT_STATSPELLBONUS_TOOLTIP;

	DemonSpellDamageFrame:Show();
end

function DemonDataSetStats()
	for i=1, 5, 1 do
		local label = _G["DemonStatFrame"..i.."Label"];
		local text = _G["DemonStatFrame"..i.."StatText"];
		local frame = _G["DemonStatFrame"..i];

		label:SetText(format(STAT_FORMAT, _G["SPELL_STAT"..i.."_NAME"]));
		stat, effectiveStat, posBuff, negBuff = _G["SelectedDemonStat"..i];
		-- Set the tooltip text
		local tooltipText = HIGHLIGHT_FONT_COLOR_CODE..format(PAPERDOLLFRAME_TOOLTIP_FORMAT, _G["SPELL_STAT"..i.."_NAME"]).." ";

			text:SetText(_G["SelectedDemonStat"..i]);
			frame.tooltip = tooltipText.._G["SelectedDemonStat"..i]..FONT_COLOR_CODE_CLOSE;
		
		-- Second tooltip line
		frame.tooltip2 = _G["DEFAULT_STAT"..i.."_TOOLTIP"];
		if ( i == 1 ) then
			local attackPower = SelectedDemonStat1-20;
			frame.tooltip2 = format(frame.tooltip2, attackPower);
		elseif ( i == 2 ) then
		--	local newLineIndex = strfind(frame.tooltip2, "|n")+1;
		--	frame.tooltip2 = strsub(frame.tooltip2, 1, newLineIndex);
			frame.tooltip2 = format(frame.tooltip2, SelectedDemonCritChanceFromAgility);
		elseif ( i == 3 ) then
			local expectedHealthGain = (((stat)-20)*10+20)*SelectedDemonUnitHealthModifier;
			local realHealthGain = ((stat-20)*10+20)*SelectedDemonUnitHealthModifier;
			local healthGain = (realHealthGain)*SelectedDemonUnitMaxHealthModifier;
			frame.tooltip2 = format(frame.tooltip2, healthGain);
		elseif ( i == 4 ) then
			if not ( _G["SelectedDemonMana"] == 0 ) then
				local manaGain = ((stat-20)*15+20)*SelectedDemonUnitPowerModifier;
				frame.tooltip2 = format(frame.tooltip2, manaGain, max(0, stat-10), SelectedDemonSpellCritChanceFromIntellect);
			else
		--		local newLineIndex = strfind(frame.tooltip2, "|n")+2;
		--		frame.tooltip2 = strsub(frame.tooltip2, newLineIndex);
		--		frame.tooltip2 = format(frame.tooltip2, SelectedDemonSpellCritChanceFromIntellect);
				frame.tooltip2 = nil;
			end
		elseif ( i == 5 ) then
			frame.tooltip2 = "";
		--	frame.tooltip2 = format(frame.tooltip2, SelectedDemonUnitHealthRegenRateFromSpirit);
			if not ( _G["SelectedDemonMana"] == 0 ) then
		--		frame.tooltip2 = frame.tooltip2.."\n"..format(MANA_REGEN_FROM_SPIRIT, SelectedDemonUnitManaRegenRateFromSpirit);
				frame.tooltip2 = format(MANA_REGEN_FROM_SPIRIT, SelectedDemonUnitManaRegenRateFromSpirit);
			end
		end
	end
end

function DemonDataSetArmor()
	local base = _G["SelectedDemonArmor"];
	local level = _G["SelectedDemonLevel"];
	local posBuff, negBuff = 0, 0
	_G["DemonArmorFrameLabel"]:SetText(format(STAT_FORMAT, ARMOR));
	local text = _G["DemonArmorFrameStatText"];

	PaperDollFormatStat(ARMOR, base, posBuff, negBuff, DemonArmorFrame, text);
	local armorReduction = PaperDollFrame_GetArmorReduction(base, tonumber(level));
	DemonArmorFrame.tooltip2 = format(DEFAULT_STATARMOR_TOOLTIP, armorReduction);
	
	text:SetText(_G["SelectedDemonArmor"])
	DemonArmorFrame:Show();
end


function SortDemon()
end

function DemonDataSetDamage()
	_G["DemonDamageFrameLabel"]:SetText(format(STAT_FORMAT, DAMAGE));
	local frame = DemonDamageFrame
	local text = _G["DemonDamageFrameStatText"];

	local displayMin = max(floor(SelectedDemonMinDamage),1);
	local displayMax = max(ceil(SelectedDemonMaxDamage),1);

	local minDamage = (SelectedDemonMinDamage / SelectedDemonPercent);
	local maxDamage = (SelectedDemonMaxDamage / SelectedDemonPercent);

	local baseDamage = (minDamage + maxDamage) * 0.5;
	local fullDamage = baseDamage * SelectedDemonPercent;
	local totalBonus = (fullDamage - baseDamage);
	local damagePerSecond = (max(fullDamage,1) / SelectedDemonSpeed);
	local damageTooltip = max(floor(minDamage),1).." - "..max(ceil(maxDamage),1);
	
	local colorPos = "|cff20ff20";
	local colorNeg = "|cffff2020";

	if ( totalBonus == 0 ) then
		if ( ( displayMin < 100 ) and ( displayMax < 100 ) ) then 
			text:SetText(displayMin.." - "..displayMax);	
		else
			text:SetText(displayMin.."-"..displayMax);
		end
	else
		
		local color;
		if ( totalBonus > 0 ) then
			color = colorPos;
		else
			color = colorNeg;
		end
		if ( ( displayMin < 100 ) and ( displayMax < 100 ) ) then 
			text:SetText(color..displayMin.." - "..displayMax.."|r");	
		else
			text:SetText(color..displayMin.."-"..displayMax.."|r");
		end
		if ( SelectedDemonPercent > 1 ) then
			damageTooltip = damageTooltip..colorPos.." x"..floor(SelectedDemonPercent*100+0.5).."%|r";
		elseif ( SelectedDemonPercent < 1 ) then
			damageTooltip = damageTooltip..colorNeg.." x"..floor(SelectedDemonPercent*100+0.5).."%|r";
		end
		
	end
	frame.damage = damageTooltip;
	frame.attackSpeed = SelectedDemonSpeed;
	frame.dps = damagePerSecond;

	-- If there's an offhand speed then add the offhand info to the tooltip
	if ( not SelectedDemonOHSpeed == "") then
		minOffHandDamage = (SelectedDemonMinOHDamage / SelectedDemonPercent);
		maxOffHandDamage = (SelectedDemonMaxOHDamage / SelectedDemonPercent);

		local offhandBaseDamage = (minOffHandDamage + maxOffHandDamage) * 0.5;
		local offhandFullDamage = (offhandBaseDamage) * SelectedDemonPercent;
		local offhandDamagePerSecond = (max(offhandFullDamage,1) / SelectedDemonOHSpeed);
		local offhandDamageTooltip = max(floor(minOffHandDamage),1).." - "..max(ceil(maxOffHandDamage),1);

		if ( SelectedDemonPercent > 1 ) then
			offhandDamageTooltip = offhandDamageTooltip..colorPos.." x"..floor(SelectedDemonPercent*100+0.5).."%|r";
		elseif ( SelectedDemonPercent < 1 ) then
			offhandDamageTooltip = offhandDamageTooltip..colorNeg.." x"..floor(SelectedDemonPercent*100+0.5).."%|r";
		end
		frame.offhandDamage = offhandDamageTooltip;
		frame.offhandAttackSpeed = SelectedDemonOHSpeed;
		frame.offhandDps = offhandDamagePerSecond;
	else
		frame.offhandAttackSpeed = nil;
	end
--	statFrame:Show();
end

function DemonDamageFrame_OnEnter (self)
	-- Main hand weapon
	GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
	if ( self == DemonDamageFrame ) then
		GameTooltip:SetText(INVTYPE_WEAPONMAINHAND_PET, HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
	else
		GameTooltip:SetText(INVTYPE_WEAPONMAINHAND, HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
	end
	GameTooltip:AddDoubleLine(format(STAT_FORMAT, ATTACK_SPEED_SECONDS), format("%.2f", self.attackSpeed), NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b);
	GameTooltip:AddDoubleLine(format(STAT_FORMAT, DAMAGE), self.damage, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b);
	GameTooltip:AddDoubleLine(format(STAT_FORMAT, DAMAGE_PER_SECOND), format("%.1f", self.dps), NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b);
	-- Check for offhand weapon
	if ( self.offhandAttackSpeed ) then
		GameTooltip:AddLine("\n");
		GameTooltip:AddLine(INVTYPE_WEAPONOFFHAND, HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
		GameTooltip:AddDoubleLine(format(STAT_FORMAT, ATTACK_SPEED_SECONDS), format("%.2f", self.offhandAttackSpeed), NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b);
		GameTooltip:AddDoubleLine(format(STAT_FORMAT, DAMAGE), self.offhandDamage, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b);
		GameTooltip:AddDoubleLine(format(STAT_FORMAT, DAMAGE_PER_SECOND), format("%.1f", self.offhandDps), NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b);
	end
	GameTooltip:Show();
end

function DemonFrame_GetResistances()
		
	Rbase1, Rresistance1, Rpositive1, Rnegative1 = UnitResistance("pet", 6);

	Rbase2, Rresistance2, Rpositive2, Rnegative2 = UnitResistance("pet", 2);

	Rbase3, Rresistance3, Rpositive3, Rnegative3 = UnitResistance("pet", 3);

	Rbase4, Rresistance4, Rpositive4, Rnegative4 = UnitResistance("pet", 4);

	Rbase5, Rresistance5, Rpositive5, Rnegative5 = UnitResistance("pet", 5);


--_G["PetMagicResFrame1"]:GetID()

end

function DemonFrame_SetResistances()
	local DemonOffset = FauxScrollFrame_GetOffset(DemonListScrollFrame);

for SD = 1, DEMONS_TO_DISPLAY do
	SDPOS = DemonOffset + SD;
	if (_G["DemonTitleButton"..SD.."Name"]:GetText() == SelectedDemonName) then

		local text1 = _G["DemonMagicResText1"];
		local frame1 = _G["DemonMagicResFrame1"];
		local text2 = _G["DemonMagicResText2"];
		local frame2 = _G["DemonMagicResFrame2"];
		local text3 = _G["DemonMagicResText3"];
		local frame3 = _G["DemonMagicResFrame3"];
		local text4 = _G["DemonMagicResText4"];
		local frame4 = _G["DemonMagicResFrame4"];
		local text5 = _G["DemonMagicResText5"];
		local frame5 = _G["DemonMagicResFrame5"];

		local resistance1Name = _G["RESISTANCE"..frame1:GetID().."_NAME"];
		local resistance2Name = _G["RESISTANCE"..frame2:GetID().."_NAME"];
		local resistance3Name = _G["RESISTANCE"..frame3:GetID().."_NAME"];
		local resistance4Name = _G["RESISTANCE"..frame4:GetID().."_NAME"];
		local resistance5Name = _G["RESISTANCE"..frame5:GetID().."_NAME"];
		local resistance1IconCode = "|TInterface\\PaperDollInfoFrame\\SpellSchoolIcon"..(frame1:GetID()+1)..":0|t";
		local resistance2IconCode = "|TInterface\\PaperDollInfoFrame\\SpellSchoolIcon"..(frame2:GetID()+1)..":0|t";
		local resistance3IconCode = "|TInterface\\PaperDollInfoFrame\\SpellSchoolIcon"..(frame3:GetID()+1)..":0|t";
		local resistance4IconCode = "|TInterface\\PaperDollInfoFrame\\SpellSchoolIcon"..(frame4:GetID()+1)..":0|t";
		local resistance5IconCode = "|TInterface\\PaperDollInfoFrame\\SpellSchoolIcon"..(frame5:GetID()+1)..":0|t";
	
	if( RES1[SDPOS] ) then

		frame1.tooltip = resistance1IconCode.." "..HIGHLIGHT_FONT_COLOR_CODE..format(PAPERDOLLFRAME_TOOLTIP_FORMAT, resistance1Name).." "..RES1[SDPOS]..FONT_COLOR_CODE_CLOSE;
		frame2.tooltip = resistance2IconCode.." "..HIGHLIGHT_FONT_COLOR_CODE..format(PAPERDOLLFRAME_TOOLTIP_FORMAT, resistance2Name).." "..RES2[SDPOS]..FONT_COLOR_CODE_CLOSE;
		frame3.tooltip = resistance3IconCode.." "..HIGHLIGHT_FONT_COLOR_CODE..format(PAPERDOLLFRAME_TOOLTIP_FORMAT, resistance3Name).." "..RES3[SDPOS]..FONT_COLOR_CODE_CLOSE;
		frame4.tooltip = resistance4IconCode.." "..HIGHLIGHT_FONT_COLOR_CODE..format(PAPERDOLLFRAME_TOOLTIP_FORMAT, resistance4Name).." "..RES4[SDPOS]..FONT_COLOR_CODE_CLOSE;
		frame5.tooltip = resistance5IconCode.." "..HIGHLIGHT_FONT_COLOR_CODE..format(PAPERDOLLFRAME_TOOLTIP_FORMAT, resistance5Name).." "..RES5[SDPOS]..FONT_COLOR_CODE_CLOSE;

		-- resistances can now be negative. Show Red if negative, Green if positive, white otherwise
		if( RES1[SDPOS] < 0 ) then
			text1:SetText(RED_FONT_COLOR_CODE..RES1[SDPOS]..FONT_COLOR_CODE_CLOSE);
		elseif( RES1[SDPOS] == 0 ) then
			text1:SetText(RES1[SDPOS]);
		else
			text1:SetText(GREEN_FONT_COLOR_CODE..RES1[SDPOS]..FONT_COLOR_CODE_CLOSE);
		end
		if( RES2[SDPOS] < 0 ) then
			text2:SetText(RED_FONT_COLOR_CODE..RES2[SDPOS]..FONT_COLOR_CODE_CLOSE);
		elseif( RES2[SDPOS] == 0 ) then
			text2:SetText(RES2[SDPOS]);
		else
			text2:SetText(GREEN_FONT_COLOR_CODE..RES2[SDPOS]..FONT_COLOR_CODE_CLOSE);
		end
		if( RES3[SDPOS] < 0 ) then
			text3:SetText(RED_FONT_COLOR_CODE..RES3[SDPOS]..FONT_COLOR_CODE_CLOSE);
		elseif( RES3[SDPOS] == 0 ) then
			text3:SetText(RES3[SDPOS]);
		else
			text3:SetText(GREEN_FONT_COLOR_CODE..RES3[SDPOS]..FONT_COLOR_CODE_CLOSE);
		end
		if( RES4[SDPOS] < 0 ) then
			text4:SetText(RED_FONT_COLOR_CODE..RES4[SDPOS]..FONT_COLOR_CODE_CLOSE);
		elseif( RES4[SDPOS] == 0 ) then
			text4:SetText(RES4[SDPOS]);
		else
			text4:SetText(GREEN_FONT_COLOR_CODE..RES4[SDPOS]..FONT_COLOR_CODE_CLOSE);
		end
		if( RES5[SDPOS] < 0 ) then
			text5:SetText(RED_FONT_COLOR_CODE..RES5[SDPOS]..FONT_COLOR_CODE_CLOSE);
		elseif( RES5[SDPOS] == 0 ) then
			text5:SetText(RES5[SDPOS]);
		else
			text5:SetText(GREEN_FONT_COLOR_CODE..RES5[SDPOS]..FONT_COLOR_CODE_CLOSE);
		end

	local DunitLevel = max(DLEVELS[SDPOS], 20);
		local DmagicResistance1Number = tonumber(RES1[SDPOS]/DunitLevel);
		local DmagicResistance2Number = tonumber(RES2[SDPOS]/DunitLevel);
		local DmagicResistance3Number = tonumber(RES3[SDPOS]/DunitLevel);
		local DmagicResistance4Number = tonumber(RES4[SDPOS]/DunitLevel);
		local DmagicResistance5Number = tonumber(RES5[SDPOS]/DunitLevel);


		frame1.tooltipSubtext = format(RESISTANCE_TOOLTIP_SUBTEXT, _G["SPELL_SCHOOL"..frame1:GetID().."_CAP"], ResistancePercent(RES1[SDPOS], DLEVELS[SDPOS]));
		frame2.tooltipSubtext = format(RESISTANCE_TOOLTIP_SUBTEXT, _G["SPELL_SCHOOL"..frame2:GetID().."_CAP"], ResistancePercent(RES2[SDPOS], DLEVELS[SDPOS]));
		frame3.tooltipSubtext = format(RESISTANCE_TOOLTIP_SUBTEXT, _G["SPELL_SCHOOL"..frame3:GetID().."_CAP"], ResistancePercent(RES3[SDPOS], DLEVELS[SDPOS]));
		frame4.tooltipSubtext = format(RESISTANCE_TOOLTIP_SUBTEXT, _G["SPELL_SCHOOL"..frame4:GetID().."_CAP"], ResistancePercent(RES4[SDPOS], DLEVELS[SDPOS]));
		frame5.tooltipSubtext = format(RESISTANCE_TOOLTIP_SUBTEXT, _G["SPELL_SCHOOL"..frame5:GetID().."_CAP"], ResistancePercent(RES5[SDPOS], DLEVELS[SDPOS]));
		
	end
	end
end
end

function DemonRaceSet()
	local dt = CreateFrame("DressUpModel", "Dtest", UiParent)
	dt:SetUnit("pet")

	if (dt:GetModel() == "creature\\imp\\imp.m2") then
		DRACE = DRACE4;
	elseif (dt:GetModel() == "creature\\felguard\\felguard.m2") then
		DRACE = DRACE2;
	elseif (dt:GetModel() == "creature\\succubus\\succubus.m2") then
		DRACE = DRACE1;
	elseif (dt:GetModel() == "creature\\dreadlord\\dreadlord.m2") or (dt:GetModel() == "creature\\malganis\\malganis.m2")then
		DRACE = DRACE3;
	elseif (dt:GetModel() == "creature\\shivan\\shivan.m2") then
		DRACE = DRACE5;
	elseif (dt:GetModel() == "creature\\wrathguard\\wrathguard.m2") then
		DRACE = DRACE6;
	elseif (dt:GetModel() == "creature\\voidwalker\\voidwalker.m2") then
		DRACE = DRACE7;
	elseif (dt:GetModel() == "creature\\voidterror\\voidterror.m2") then
		DRACE = DRACE8;
	elseif (dt:GetModel() == "creature\\felhound\\felhound.m2") then
		DRACE = DRACE9;
	elseif (dt:GetModel() == "creature\\felboar\\felboar.m2") then
		DRACE = DRACE10;
	elseif (dt:GetModel() == "creature\\voidgod\\voidgod.m2") or (dt:GetModel() == "creature\\voidwraith\\voidwraith.m2") then
		DRACE = DRACE11;
	elseif (dt:GetModel() == "creature\\impoutland\\impoutland.m2") then
		DRACE = DRACE12;
	elseif (dt:GetModel() == "creature\\magehunter\\magehunter.m2") or (dt:GetModel() == "creature\\darkhound\\darkhound.m2") then
		DRACE = DRACE13;
	elseif (dt:GetModel() == "creature\\satyr\\satyr.m2") then
		DRACE = DRACE14;
	elseif (dt:GetModel() == "creature\\beholder\\beholder.m2") then
		DRACE = DRACE15;
	elseif (dt:GetModel() == "creature\\moargminion\\moargminion.m2") then
		DRACE = DRACE16;
	elseif (dt:GetModel() == "creature\\moarg\\moarg1.m2") or (dt:GetModel() == "creature\\moarg\\moarg2.m2") or (dt:GetModel() == "creature\\moarg\\moarg3.m2") or (dt:GetModel() == "creature\\moarg\\moarg4.m2") or (dt:GetModel() == "creature\\moarg\\moarg5.m2") or (dt:GetModel() == "creature\\moarg\\moarg6 .m2") then
		DRACE = DRACE17;
	elseif (dt:GetModel() == "creature\\felbeast\\felbeast.m2") or (dt:GetModel() == "creature\\felbeastshadowmoon\\felbeastshadowmoon.m2") then
		DRACE = DRACE18;
	elseif (dt:GetModel() == "creature\\infernal\\infernal.m2") then
		DRACE = DRACE19;
	elseif (dt:GetModel() == "creature\\abyssaloutland\\abyssal_outland.m2") or (dt:GetModel() == "creature\\abyssalillidan\\abyssal_illidan.m2") then
		DRACE = DRACE20;
	elseif (dt:GetModel() == "creature\\doomguard\\doomguard.m2") then
		DRACE = DRACE21;
	elseif (dt:GetModel() == "creature\\doomguardoutland\\doomguardoutland.m2") then
		DRACE = DRACE22;
	elseif (dt:GetModel() == "creature\\pitlord\\pitlord.m2") or (dt:GetModel() == "creature\\pitlord\\magtheridon.m2") or (dt:GetModel() == "creature\\brutallus\\brutallus.m2") then
		DRACE = DRACE23;
	elseif (dt:GetModel() == "creature\\eredar\\eredar.m2") or (dt:GetModel() == "creature\\eredar\\archimonde.m2") then
		DRACE = DRACE24;
	elseif (dt:GetModel() == "creature\\nightmare\\nightmare.m2") or (dt:GetModel() == "creature\\nightmare\\gorgon101.m2") then
		DRACE = DRACE25;
	elseif (dt:GetModel() == "creature\\fireelemental\\fireelemental.m2") then
		DRACE = DRACE27;
	elseif (dt:GetModel() == "creature\\gargoyle\\gargoyle.m2") then
		DRACE = DRACE28;
	elseif (dt:GetModel() == "creature\\voidcaller\\voidcaller.m2") or (dt:GetModel() == "creature\\voidwalkeroutland\\voidwalker_outland.m2") or (dt:GetModel() == "creature\\voidlord\\voidlord.m2") then
		DRACE = DRACE29;
	else
		DRACE = DRACE26;
	end
	table.insert(RaceListDatabase, DRACE);
--out(dt:GetModel())
dt:ClearModel()
end

function DemonActionBar_Track (self)

		Dname4, Dsubtext4, Dtexture4, DisToken4, DisActive4, DautoCastAllowed4, DautoCastEnabled4 = GetPetActionInfo(4);
		Dname5, Dsubtext5, Dtexture5, DisToken5, DisActive5, DautoCastAllowed5, DautoCastEnabled5 = GetPetActionInfo(5);
		Dname6, Dsubtext6, Dtexture6, DisToken6, DisActive6, DautoCastAllowed6, DautoCastEnabled6 = GetPetActionInfo(6);
		Dname7, Dsubtext7, Dtexture7, DisToken7, DisActive7, DautoCastAllowed7, DautoCastEnabled7 = GetPetActionInfo(7);

DemonId1 = GetSpellID(Dname4)
DemonId2 = GetSpellID(Dname5)
DemonId3 = GetSpellID(Dname6)
DemonId4 = GetSpellID(Dname7)


		if (not Dname4) then
			Dname4 = ""
			Dsubtext4 = ""
			Dtexture4 = ""
			DemonId1 = ""
		end
		if (not Dname5) then
			Dname5 = ""
			Dsubtext5 = ""
			Dtexture5 = ""
			DemonId2 = ""
		end		
		if (not Dname6) then
			Dname6 = ""
			Dsubtext6 = ""
			Dtexture6 = ""
			DemonId3 = ""
		end
		if (not Dname7) then
			Dname7 = ""
			Dsubtext7 = ""
			Dtexture7 = ""
			DemonId4 = ""
		end
end

function DemonDataSetSkills ()
	local demonActionButton, demonActionIcon, demonAutoCastableTexture, demonAutoCastShine;
		local buttonName4 = "DemonActionButton4";
		local buttonName5 = "DemonActionButton5";
		local buttonName6 = "DemonActionButton6";
		local buttonName7 = "DemonActionButton7";
		demonActionButton4 = _G[buttonName4];
		demonActionButton5 = _G[buttonName5];
		demonActionButton6 = _G[buttonName6];
		demonActionButton7 = _G[buttonName7];
		demonActionIcon4 = _G[buttonName4.."Icon"];
		demonActionIcon5 = _G[buttonName5.."Icon"];
		demonActionIcon6 = _G[buttonName6.."Icon"];
		demonActionIcon7 = _G[buttonName7.."Icon"];
		demonActionTitle4 = _G["DemonActionButton4Title"];
		demonActionTitle5 = _G["DemonActionButton5Title"];
		demonActionTitle6 = _G["DemonActionButton6Title"];
		demonActionTitle7 = _G["DemonActionButton7Title"];

			demonActionIcon4:SetTexture(_G["SelectedDemonSkill1Texture"]);
			demonActionButton4.tooltipName = _G["SelectedDemonSkill1Name"];
			demonActionIcon5:SetTexture(_G["SelectedDemonSkill2Texture"]);
			demonActionButton5.tooltipName = _G["SelectedDemonSkill2Name"];
			demonActionIcon6:SetTexture(_G["SelectedDemonSkill3Texture"]);
			demonActionButton6.tooltipName = _G["SelectedDemonSkill3Name"];
			demonActionIcon7:SetTexture(_G["SelectedDemonSkill4Texture"]);
			demonActionButton7.tooltipName = _G["SelectedDemonSkill4Name"];

		demonActionButton4.tooltipSubtext = _G["SelectedDemonSkill1SubText"];
		demonActionButton5.tooltipSubtext = _G["SelectedDemonSkill2SubText"];
		demonActionButton6.tooltipSubtext = _G["SelectedDemonSkill3SubText"];
		demonActionButton7.tooltipSubtext = _G["SelectedDemonSkill4SubText"];
		if ( _G["SelectedDemonSkill1Name"] ) then
			demonActionButton4:Show();
		else
			demonActionButton4:Hide();
		end
		if ( _G["SelectedDemonSkill2Name"] ) then
			demonActionButton5:Show();
		else
			demonActionButton5:Hide();
		end
		if ( _G["SelectedDemonSkill3Name"] ) then
			demonActionButton6:Show();
		else
			demonActionButton6:Hide();
		end
		if ( _G["SelectedDemonSkill4Name"] ) then
			demonActionButton7:Show();
		else
			demonActionButton7:Hide();
		end
		if ( _G["SelectedDemonSkill1Texture"] ) then
		--	if ( GetPetActionSlotUsable(4) ) then
				SetDesaturation(demonActionIcon4, nil);
		--	else
		--		SetDesaturation(demonActionIcon4, 1);
		--	end
			demonActionIcon4:Show();
			demonActionButton4:SetNormalTexture("Interface\\Buttons\\UI-Quickslot2");
		else
			demonActionIcon4:Hide();
			demonActionButton4:SetNormalTexture("Interface\\Buttons\\UI-Quickslot");
		end
		if ( _G["SelectedDemonSkill2Texture"] ) then
		--	if ( GetPetActionSlotUsable(5) ) then
				SetDesaturation(demonActionIcon5, nil);
		--	else
		--		SetDesaturation(demonActionIcon5, 1);
		--	end
			demonActionIcon5:Show();
			demonActionButton5:SetNormalTexture("Interface\\Buttons\\UI-Quickslot2");
		else
			demonActionIcon5:Hide();
			demonActionButton5:SetNormalTexture("Interface\\Buttons\\UI-Quickslot");
		end
		if ( _G["SelectedDemonSkill3Texture"] ) then
		--	if ( GetPetActionSlotUsable(6) ) then
				SetDesaturation(demonActionIcon6, nil);
		--	else
		--		SetDesaturation(demonActionIcon6, 1);
		--	end
			demonActionIcon6:Show();
			demonActionButton6:SetNormalTexture("Interface\\Buttons\\UI-Quickslot2");
		else
			demonActionIcon6:Hide();
			demonActionButton6:SetNormalTexture("Interface\\Buttons\\UI-Quickslot");
		end
		if ( _G["SelectedDemonSkill4Texture"] ) then
			if ( GetPetActionSlotUsable(7) ) then
				SetDesaturation(demonActionIcon7, nil);
			else
				SetDesaturation(demonActionIcon7, 1);
			end
			demonActionIcon7:Show();
			demonActionButton7:SetNormalTexture("Interface\\Buttons\\UI-Quickslot2");
		else
			demonActionIcon7:Hide();
			demonActionButton7:SetNormalTexture("Interface\\Buttons\\UI-Quickslot");
		end


		if ( not SelectedDemonSkill1SubText ) then
			demonActionTitle4:SetText(SelectedDemonSkill1Name)
		else
			demonActionTitle4:SetText(SelectedDemonSkill1Name.." ("..SelectedDemonSkill1SubText..")")
		end
		if ( not SelectedDemonSkill2SubText ) then
			demonActionTitle5:SetText(SelectedDemonSkill2Name)
		else
			demonActionTitle5:SetText(SelectedDemonSkill2Name.." ("..SelectedDemonSkill2SubText..")")
		end
		if ( not SelectedDemonSkill3SubText ) then
			demonActionTitle6:SetText(SelectedDemonSkill3Name)
		else
			demonActionTitle6:SetText(SelectedDemonSkill3Name.." ("..SelectedDemonSkill3SubText..")")
		end
		if ( not SelectedDemonSkill4SubText ) then
			demonActionTitle7:SetText( SelectedDemonSkill4Name )
		else
			demonActionTitle7:SetText(SelectedDemonSkill4Name.." ("..SelectedDemonSkill4SubText..")")
		end
end


function DemonActionButton1Click (self, button)
	if ( IsModifiedClick("SHIFT") ) then
		DEFAULT_CHAT_FRAME:AddMessage("|cff71d5ff|Hspell:"..SelectedDemonSkill1Id.."|h["..SelectedDemonSkill1Name.."]|h|r")
		return;
	end
end
function DemonActionButton2Click (self, button)
	if ( IsModifiedClick("SHIFT") ) then
		DEFAULT_CHAT_FRAME:AddMessage("|cff71d5ff|Hspell:"..SelectedDemonSkill2Id.."|h["..SelectedDemonSkill2Name.."]|h|r")
		return;
	end
end
function DemonActionButton3Click (self, button)
	if ( IsModifiedClick("SHIFT") ) then
		DEFAULT_CHAT_FRAME:AddMessage("|cff71d5ff|Hspell:"..SelectedDemonSkill3Id.."|h["..SelectedDemonSkill3Name.."]|h|r")
		return;
	end
end
function DemonActionButton4Click (self, button)
	if ( IsModifiedClick("SHIFT") ) then
		DEFAULT_CHAT_FRAME:AddMessage("|cff71d5ff|Hspell:"..SelectedDemonSkill4Id.."|h["..SelectedDemonSkill4Name.."]|h|r")
		return;
	end
end

function DemonActionButton4_OnEnter (self)
		GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
		GameTooltip:SetHyperlink("|cff71d5ff|Hspell:"..SelectedDemonSkill1Id.."|h["..SelectedDemonSkill1Name.."]|h|r");
--		GameTooltip:SetPetAction(self:GetID());
end
function DemonActionButton5_OnEnter (self)
		GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
		GameTooltip:SetHyperlink("|cff71d5ff|Hspell:"..SelectedDemonSkill2Id.."|h["..SelectedDemonSkill2Name.."]|h|r");
end
function DemonActionButton6_OnEnter (self)
		GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
		GameTooltip:SetHyperlink("|cff71d5ff|Hspell:"..SelectedDemonSkill3Id.."|h["..SelectedDemonSkill3Name.."]|h|r");
end
function DemonActionButton7_OnEnter (self)
		GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
		GameTooltip:SetHyperlink("|cff71d5ff|Hspell:"..SelectedDemonSkill4Id.."|h["..SelectedDemonSkill4Name.."]|h|r");
end

function GetSpellID(spell)

    local name

    for i = 1, 100000 do

        name = GetSpellInfo(i)

        if name == spell then

            return i

        end

    end

end


--bring the model to life and set the displayID (thanks to WowModelViewer (who took them from _NPCScan) for these lines of code)

function GOATS_setModel(unit)

   local GOATS_Model_TT = CreateFrame( "GameTooltip", "GOATS_DEMONID", UIParent );
   local GOATS_Model_TT_Text = GOATS_Model_TT:CreateFontString( "$parentTextLeft1", nil, "GameTooltipText" );
   GOATS_Model_TT:AddFontStrings( GOATS_Model_TT_Text, GOATS_Model_TT:CreateFontString( "$parentTextRight1", nil, "GameTooltipText" ) );
   GOATS_Model_TT:SetOwner( WorldFrame, "ANCHOR_NONE" );

	for i=0,GOATS_DEMONID_MAX do
		GOATS_Model_TT_Text:SetText(nil);
		GOATS_Model_TT:SetOwner( WorldFrame, "ANCHOR_NONE" );
		GOATS_Model_TT:SetHyperlink("unit:F53"..strrep("0",5 - string.len(format("%X",i)))..format("%X",i).."00000000");     

		if ( GOATS_Model_TT_Text:GetText() ) then
			table.insert(DemonIDDB,i,GOATS_Model_TT_Text:GetText());
		end
	end	  
end

function GOATS_ShowModel()
	RaceModelText:Hide();
	DemonModelFrame:ClearModel()
	DemonModelFrame:SetModel("Interface/Buttons/talktomequestionmark.m2")	--If not in cache then ?

	if (SelectedDemonRace == D_SUCCUBUS) then			--Atleast show race model!
		DemonModelFrame:SetDisplayInfo(4162); 
		RaceModelText:Show();
	elseif (SelectedDemonRace == D_FELGUARD) then
		DemonModelFrame:SetDisplayInfo(5047);
		DemonModelFrame:TryOn("|cff1eff00|Hitem:12784:0:0:0:0:0:-44:-1664483297:76:0:0|h[Arcanite Reaper]|h|r");
		RaceModelText:Show();
	elseif (SelectedDemonRace == D_DREADLORD) then
		DemonModelFrame:SetDisplayInfo(130);
		RaceModelText:Show();
	elseif (SelectedDemonRace == D_IMP) then
		DemonModelFrame:SetDisplayInfo(4449);
		RaceModelText:Show();
	elseif (SelectedDemonRace == D_SHIVAN) then
		DemonModelFrame:SetDisplayInfo(22596);
		RaceModelText:Show();
	elseif (SelectedDemonRace == D_WRATHGUARD) then
		DemonModelFrame:SetDisplayInfo(20041);
		RaceModelText:Show();
	elseif (SelectedDemonRace == D_VOIDWALKER) then
		DemonModelFrame:SetDisplayInfo(1131);
		RaceModelText:Show();
	elseif (SelectedDemonRace == D_VOID_TERROR) then
		DemonModelFrame:SetDisplayInfo(14173);
		RaceModelText:Show();
	elseif (SelectedDemonRace == D_FELHOUND) then
		DemonModelFrame:SetDisplayInfo(850);
		RaceModelText:Show();
	elseif (SelectedDemonRace == D_BOAR) then
		DemonModelFrame:SetDisplayInfo(19249);
		RaceModelText:Show();
	elseif (SelectedDemonRace == D_VOIDWRAITH) then
		DemonModelFrame:SetDisplayInfo(18050);
		RaceModelText:Show();
	elseif (SelectedDemonRace == D_OUTLANDSIMP) then
		DemonModelFrame:SetDisplayInfo(16888);
		RaceModelText:Show();
	elseif (SelectedDemonRace == D_DARKHOUND) then
		DemonModelFrame:SetDisplayInfo(9021);
		RaceModelText:Show();
	elseif (SelectedDemonRace == D_SATYR) then
		DemonModelFrame:SetDisplayInfo(2012);
		RaceModelText:Show();
	elseif (SelectedDemonRace == D_BEHOLDER) then
		DemonModelFrame:SetDisplayInfo(19579);
		RaceModelText:Show();
	elseif (SelectedDemonRace == D_GANARG) then
		DemonModelFrame:SetDisplayInfo(19189);
		RaceModelText:Show();
	elseif (SelectedDemonRace == D_MOARG) then
		DemonModelFrame:SetDisplayInfo(19035);
		RaceModelText:Show();
	elseif (SelectedDemonRace == D_CORE_HOUND) then
		DemonModelFrame:SetDisplayInfo(12189);
		RaceModelText:Show();
	elseif (SelectedDemonRace == D_INFERNAL) then
		DemonModelFrame:SetDisplayInfo(25958);
		RaceModelText:Show();
	elseif (SelectedDemonRace == D_ABYSSAL) then
		DemonModelFrame:SetDisplayInfo(18139);
		RaceModelText:Show();
	elseif (SelectedDemonRace == D_DOOMGUARD) then
		DemonModelFrame:SetDisplayInfo(433);
		RaceModelText:Show();
	elseif (SelectedDemonRace == D_FIEND) then
		DemonModelFrame:SetDisplayInfo(18169);
		RaceModelText:Show();
	elseif (SelectedDemonRace == D_PIT_LORD) then
		DemonModelFrame:SetDisplayInfo(20751);
		RaceModelText:Show();
	elseif (SelectedDemonRace == D_EREDAR) then
		DemonModelFrame:SetDisplayInfo(19949);
		RaceModelText:Show();
	elseif (SelectedDemonRace == D_NIGHTMARE) then
		DemonModelFrame:SetDisplayInfo(2346);
		RaceModelText:Show();
	elseif (SelectedDemonRace == D_INFSOUL) then
		DemonModelFrame:SetDisplayInfo(14518);
		RaceModelText:Show();
	elseif (SelectedDemonRace == D_GARGOYLE) then
		DemonModelFrame:SetDisplayInfo(17311);
		RaceModelText:Show();
	elseif (SelectedDemonRace == D_ARMORWALKER) then
		DemonModelFrame:SetDisplayInfo(18953);
		RaceModelText:Show();
	end

	for i=0,GOATS_DEMONID_MAX do
		if (DemonIDDB[i] == SelectedDemonName) then
			DemonModelFrame:ClearModel()
			DemonModelFrame:SetCreature(i)			--True model
			RaceModelText:Hide()
		end
	end

--	DemonModelFrame:SetCreature(48764) --Telarius Voidstrider

--	DemonModelFrame:SetCamera(1)

--	DemonModelFrame:TryOn("|cff1eff00|Hitem:32837:0:0:0:0:0:-44:-1664483297:76:0:0|h[Warglaive of Azzinoth]|h|r")	--32837/32838
--	DemonModelFrame:TryOn("|cff1eff00|Hitem:32838:0:0:0:0:0:-44:-1664483297:76:0:0|h[Warglaive of Azzinoth(Izq)]|h|r")	--32837/32838

--	item:itemId:enchantId:jewelId1:jewelId2:jewelId3:jewelId4:suffixId:uniqueId:linkLevel:reforgeId

--	if not ( tContains(DemonIDDB, SelectedDemonName)) and not ( tContains(DemonIDDB, SelectedDemonRace) ) then
--		DemonModelFrame:ClearModel()
--		DemonModelFrame:SetModel("Interface/Buttons/talktomequestionmark.m2")
--	end

--	if (DemonModelFrame:GetModel() == "creature\\succubus\\succubus.m2" and SelectedDemonRace == D_SUCCUBUS) then
--	if not ( tContains(DemonIDDB, SelectedDemonName) and not ( tContains(DemonIDDB, SelectedDemonRace) ) then
--		DemonModelFrame:ClearModel()
--		DemonModelFrame:SetModel("Interface/Buttons/talktomequestionmark.m2")
--	end

	if (DSize) then
		DemonModelFrame:SetScale(DSize);
	else
		DemonModelFrame:SetScale(1);
	end
--	if (SelectedDemonRace == D_MOARG) then	
--		DemonModelFrame:SetPosition(-4.3, 0.7, 1.2);
--	elseif (SelectedDemonRace == D_INFERNAL) then	
--		DemonModelFrame:SetPosition(-6.76, 0, 0.46);
--	elseif (SelectedDemonRace == D_SATYR) then	
--		DemonModelFrame:SetPosition(-2.6, 0.4, -0.08);
----	elseif (Dx) and (Dy) and (Dz) then	
----		DemonModelFrame:SetPosition(Dx, Dy, Dz);
--	else
		DemonModelFrame:SetPosition(0, 0, 0);
--	end
	if (DRot) then
		DemonModelFrame:SetFacing(DRot);
	else
		DemonModelFrame:SetFacing(0);
	end

	DSize = DemonModelFrame:GetModelScale()
	Dx, Dy, Dz = DemonModelFrame:GetPosition()
	DRot = DemonModelFrame:GetFacing()
end

function GOATS_Model_RotateLeft(rotationIncrement)
	if ( not rotationIncrement ) then
		rotationIncrement = 0.03;
	end
	DRot = DRot - rotationIncrement;
	DemonModelFrame:SetFacing(DRot);
	PlaySound("igInventoryRotateCharacter");
end

function GOATS_Model_RotateRight(rotationIncrement)
	if ( not rotationIncrement ) then
		rotationIncrement = 0.03;
	end
	DRot = DRot + rotationIncrement;
	DemonModelFrame:SetFacing(DRot);
	PlaySound("igInventoryRotateCharacter");
end

function GOATS_Model_OnUpdate(self, elapsed)
	rotationsPerSecond = ROTATIONS_PER_SECOND
	elapsedTime = elapsed --Change all elapsedTime to elapsed before public
	      
	if ( _G[DemonModelFrame:GetName().."RotateLeftButton"]:GetButtonState() == "PUSHED" ) then
		DRot = DRot + (elapsedTime * 2 * PI * rotationsPerSecond);
		if ( DRot < 0 ) then
			DRot = DRot + (2 * PI);
		end
		DemonModelFrame:SetFacing(DRot);
	end
	if ( _G[DemonModelFrame:GetName().."RotateRightButton"]:GetButtonState() == "PUSHED" ) then
		DRot = DRot - (elapsedTime * 2 * PI * rotationsPerSecond);
		if ( DRot > (2 * PI) ) then
			DRot = DRot - (2 * PI);
		end
		DemonModelFrame:SetFacing(DRot);
	end
	if ( _G[DemonModelFrameMoveLeftButton:GetName()]:GetButtonState() == "PUSHED" ) then
		if ( Dy >= -20 ) then
		    Dy = Dy - (elapsedTime * 0.05 * (8 + (math.abs(Dx) * 7)));
		end
		DemonModelFrame:SetPosition(Dx, Dy, Dz);
	end
	if ( _G[DemonModelFrameMoveRightButton:GetName()]:GetButtonState() == "PUSHED" ) then
		if ( Dy <= 20 ) then
		    Dy = Dy + (elapsedTime * 0.05 * (8 + (math.abs(Dx) * 7)));
		end
		DemonModelFrame:SetPosition(Dx, Dy, Dz);
	end	

	if ( _G[DemonModelFrameMoveUpButton:GetName()]:GetButtonState() == "PUSHED" ) then
		if ( Dz <= 30 ) then
		    Dz = Dz + (elapsedTime * 0.05 * (8 + (math.abs(Dx) * 7)));
		end
		DemonModelFrame:SetPosition(Dx, Dy, Dz);
	end
	if ( _G[DemonModelFrameMoveDownButton:GetName()]:GetButtonState() == "PUSHED" ) then
		if ( Dz >= -30 ) then
	       	    Dz = Dz - (elapsedTime * 0.05 * (8 + (math.abs(Dx) * 7)));
		end
		DemonModelFrame:SetPosition(Dx, Dy, Dz);
	end
	
	if ( _G[DemonModelFrameZoomOut:GetName()]:GetButtonState() == "PUSHED" ) then
		if ( Dx <= 30 ) then
		    if Dx < 0 then
		       Dx = Dx + (elapsedTime * 0.1 * (7 + (math.abs(Dx) * 18)));          		    
		    else
		       Dx = Dx + (elapsedTime * 0.1 * 7);		    
		    end
		end
		DemonModelFrame:SetPosition(Dx, Dy, Dz);
	end
	if ( _G[DemonModelFrameZoomIn:GetName()]:GetButtonState() == "PUSHED" ) then
		if ( Dx >= -26 ) then
		    if Dx < 0 then
		       Dx = Dx - (elapsedTime * 0.1 * (7 + (math.abs(Dx) * 18)));          		    
		    else
		       Dx = Dx - (elapsedTime * 0.1 * 7);		    
		    end
		end
		DemonModelFrame:SetPosition(Dx, Dy, Dz);
	end
end

function GOATS_ModelTweakToggle(self)
   local mframe = _G["DemonModelFrameZoomIn"]
   if (mframe) then
   	if(  mframe:IsVisible() ) then
		DemonModelFrameMoveDownButton:Hide();
		DemonModelFrameMoveUpButton:Hide();
		DemonModelFrameMoveLeftButton:Hide();
		DemonModelFrameMoveRightButton:Hide();
		DemonModelFrameZoomIn:Hide();
		DemonModelFrameZoomOut:Hide();
   	else
		DemonModelFrameMoveDownButton:Show();
		DemonModelFrameMoveUpButton:Show();
		DemonModelFrameMoveLeftButton:Show();
		DemonModelFrameMoveRightButton:Show();
		DemonModelFrameZoomIn:Show();
		DemonModelFrameZoomOut:Show();
   	end
   end
end

function GOATS_ModelReset(self)
	Dx = tonumber("0")
	Dy = tonumber("0")
	Dz = tonumber("0")
	DSize = tonumber("1")
	DRot = tonumber("0")

		DemonModelFrame:SetScale(1);

		DemonModelFrame:SetPosition(0, 0, 0);

		DemonModelFrame:SetFacing(0);
end

StaticPopupDialogs["GOATS_Comment_Dialog"] = {
	text = KBASE_DEFAULT_SEARCH_TEXT,
	button1 = ACCEPT,
	button2 = DELETE,
	hasEditBox = true,
	cancels = "GOATS_Confirm_Dialog",
	OnShow = function (self, data)
	--	self.editBox:SetMaxLetters(30)
		if (SelectedDemonComment == "??") then
			self.editBox:SetText("");
		else
			self.editBox:SetText(SelectedDemonComment);
		end
		self.editBox:HighlightText();
	end,
	OnAccept = function(self, data, data2)
		local text = self.editBox:GetText();
		if (text == "") then
			GOATS_SetComment("??")
		else
			GOATS_SetComment(text)
		end
	end,
	OnCancel = function(self, data, data2)
		local text = self.editBox:GetText()
		GOATS_SetComment("??")
	end,
--	EditBoxOnEnterPressed = function(self)
--		local parent = self:GetParent():GetParent();
--		local text = self.editBox:GetText();
--		if (text == "") then
--			GOATS_SetComment("??")
--		else
--			GOATS_SetComment(text)
--		end
--		parent:Hide();
--	end,
	timeout = 0,
	whileDead = true,
--	hideOnEscape = true,
}

function GOATS_SetComment(rofl)
local DemonOffset = FauxScrollFrame_GetOffset(DemonListScrollFrame);
	for lol=1,DEMONS_TO_DISPLAY do
		lolpos = DemonOffset + lol;
		if (_G["DemonTitleButton"..lol.."Name"]:GetText() == SelectedDemonName) then
			table.remove(DCOMMENTS, lolpos);
			table.insert(DCOMMENTS, lolpos, rofl);
			
			if (DCOMMENTS[lolpos] == "??") then
				DemonPortraitFrameComment:Hide();
			else
				DemonPortraitFrameComment:Show();
			end
			DemonListScrollFrame_Update()
			SelectedDemonComment = DCOMMENTS[lolpos]
		end
	end

end

function GOATS_ShowComment (self)
	GameTooltip:SetOwner(self, "ANCHOR_RIGHT");
	GameTooltip:SetText("|c00FFCC00"..LABEL_NOTE..": |r"..SelectedDemonComment, 1, 1, 1, true);
	GameTooltip:Show();
 
end


function SortDemon(t, f)
	local a = {}
		for n in pairs(t) do table.insert(a, n) end
		table.sort(a, f)
		local i = 0      -- iterator variable
		local iter = function ()   -- iterator function
			i = i + 1
			if a[i] == nil then return nil
			else return a[i], t[a[i]]
			end
		end
	return iter
end
function printdemonyay(k)
	for title,value in SortDemon(k) do
	--	DEFAULT_CHAT_FRAME:AddMessage(title..", "..value);
	end
end


--name, type, difficultyIndex, difficultyName, maxPlayers, dynamicDifficulty, isDynamic = GetInstanceInfo()
--if (IsInInstance() =="none") then

--else

--	SetMapByID(GetCurrentMapAreaID());
--SetDungeonMapLevel(GetCurrentMapDungeonLevel())



--   à : \195\160    è : \195\168    ì : \195\172    ò : \195\178    ù : \195\185
--   á : \195\161    é : \195\169    í : \195\173    ó : \195\179    ú : \195\186
--   â : \195\162    ê : \195\170    î : \195\174    ô : \195\180    û : \195\187
--   ã : \195\163    ë : \195\171    ï : \195\175    õ : \195\181    ü : \195\188
--   ä : \195\164                    ñ : \195\177    ö : \195\182
--   æ : \195\166                                    ø : \195\184
--   ç : \195\167                                    œ : \197\147
--   Ä : \195\132   Ö : \195\150   Ü : \195\156    ß : \195\159
-- á = \195\161 ---- Á = \195\161
-- é = \195\169 ---- É = \195\137
-- í = \195\173 ---- Í = \195\141
-- ó = \195\179 ---- Ó = \195\147
-- ú = \195\186 ---- Ú = \195\154
-- ñ = \195\177 ---- Ñ = \195\145
-- ¡ = \194\161 ---- ¿ = \194\191